/* 
* This file is part of STiD135 OXFORD LLA 
* 
* Copyright (c) <2014>-<2018>, STMicroelectronics - All Rights Reserved 
* Author(s): Mathias Hilaire (mathias.hilaire@st.com), Thierry Delahaye (thierry.delahaye@st.com) for STMicroelectronics. 
* 
* License terms: BSD 3-clause "New" or "Revised" License. 
* 
* Redistribution and use in source and binary forms, with or without 
* modification, are permitted provided that the following conditions are met: 
* 
* 1. Redistributions of source code must retain the above copyright notice, this 
* list of conditions and the following disclaimer. 
* 
* 2. Redistributions in binary form must reproduce the above copyright notice, 
* this list of conditions and the following disclaimer in the documentation 
* and/or other materials provided with the distribution. 
* 
* 3. Neither the name of the copyright holder nor the names of its contributors 
* may be used to endorse or promote products derived from this software 
* without specific prior written permission. 
* 
* THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" 
* AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE 
* IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE 
* DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE 
* FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL 
* DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR 
* SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER 
* CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, 
* OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE 
* OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. 
* 
*/ 
#ifndef _DVBSX_PKTDELIN_REG_INIT_H
#define _DVBSX_PKTDELIN_REG_INIT_H

/* -------------------------------------------------------------------------
 * File name  : dvbsx_pktdelin_reg_init.h
 * File type  : C header file
 * -------------------------------------------------------------------------
 * Description:  Register map constants
 * Generated by spirit2regtest v2.24_alpha3
 * -------------------------------------------------------------------------
 */


/* Register map constants */

/* PDELCTRL0 */
#define RC8CODEW_DVBSX_PKTDELIN_PDELCTRL0                            0x00000000
#define RC8CODEW_DVBSX_PKTDELIN_PDELCTRL0__DEFAULT                   0x0       
#define FC8CODEW_DVBSX_PKTDELIN_PDELCTRL0_HEMMODE_SELECT__MASK       0x03      
#define FC8CODEW_DVBSX_PKTDELIN_PDELCTRL0_PDELDIS_BITWISE__MASK      0x04      
#define FC8CODEW_DVBSX_PKTDELIN_PDELCTRL0_INBAND_CANCEL__MASK        0x08      
#define FC8CODEW_DVBSX_PKTDELIN_PDELCTRL0_ISIOBS_MODE__MASK          0x30      
#define FC8CODEW_DVBSX_PKTDELIN_PDELCTRL0_ENDIS_COMMONPLP__MASK      0x40      
#define FC8CODEW_DVBSX_PKTDELIN_PDELCTRL0_USER_COMMONPLP__MASK       0x80      

/* PDELCTRL1 */
#define RC8CODEW_DVBSX_PKTDELIN_PDELCTRL1                            0x00000001
#define RC8CODEW_DVBSX_PKTDELIN_PDELCTRL1__DEFAULT                   0x0       
#define FC8CODEW_DVBSX_PKTDELIN_PDELCTRL1_ALGOSWRST__MASK            0x01      
#define FC8CODEW_DVBSX_PKTDELIN_PDELCTRL1_EN_MIS00__MASK             0x02      
#define FC8CODEW_DVBSX_PKTDELIN_PDELCTRL1_PKTDELIN_SYNCRST__MASK     0x04      
#define FC8CODEW_DVBSX_PKTDELIN_PDELCTRL1_HYSTEN__MASK               0x08      
#define FC8CODEW_DVBSX_PKTDELIN_PDELCTRL1_FORCE_PKTDELINUSE__MASK    0x10      
#define FC8CODEW_DVBSX_PKTDELIN_PDELCTRL1_FILTER_EN__MASK            0x20      
#define FC8CODEW_DVBSX_PKTDELIN_PDELCTRL1_FORCE_ACCEPTED__MASK       0x40      
#define FC8CODEW_DVBSX_PKTDELIN_PDELCTRL1_INV_MISMASK__MASK          0x80      

/* PDELCTRL2 */
#define RC8CODEW_DVBSX_PKTDELIN_PDELCTRL2                            0x00000002
#define RC8CODEW_DVBSX_PKTDELIN_PDELCTRL2__DEFAULT                   0x0       
#define FC8CODEW_DVBSX_PKTDELIN_PDELCTRL2_OLD_PKTFRAME__MASK         0x01      
#define FC8CODEW_DVBSX_PKTDELIN_PDELCTRL2_FRAME_MODE__MASK           0x02      
#define FC8CODEW_DVBSX_PKTDELIN_PDELCTRL2_FORCE_LONGPKT__MASK        0x04      
#define FC8CODEW_DVBSX_PKTDELIN_PDELCTRL2_DATA_UNBBSCRAMBLED__MASK   0x08      
#define FC8CODEW_DVBSX_PKTDELIN_PDELCTRL2_SPECIAL_DATA_0XFF__MASK    0x20      
#define FC8CODEW_DVBSX_PKTDELIN_PDELCTRL2_RESET_UPKO_COUNT__MASK     0x40      
#define FC8CODEW_DVBSX_PKTDELIN_PDELCTRL2_FORCE_CONTINUOUS__MASK     0x80      

/* PDELCTRL3 */
#define RC8CODEW_DVBSX_PKTDELIN_PDELCTRL3                            0x00000003
#define RC8CODEW_DVBSX_PKTDELIN_PDELCTRL3__DEFAULT                   0x0       
#define FC8CODEW_DVBSX_PKTDELIN_PDELCTRL3_ETHERNET_DISFCS__MASK      0x01      
#define FC8CODEW_DVBSX_PKTDELIN_PDELCTRL3_PKTDEL_BCHERRCONT__MASK    0x02      
#define FC8CODEW_DVBSX_PKTDELIN_PDELCTRL3_SATURATE_BBPKTKO__MASK     0x04      
#define FC8CODEW_DVBSX_PKTDELIN_PDELCTRL3_PKTDEL_NOPKTCHK__MASK      0x08      
#define FC8CODEW_DVBSX_PKTDELIN_PDELCTRL3_PKTDELIN_DELACMERR__MASK   0x10      
#define FC8CODEW_DVBSX_PKTDELIN_PDELCTRL3_NOFIFO_BCHERR__MASK        0x20      
#define FC8CODEW_DVBSX_PKTDELIN_PDELCTRL3_PKTDEL_ENLONGPKT__MASK     0x40      
#define FC8CODEW_DVBSX_PKTDELIN_PDELCTRL3_PKTDEL_CONTFAIL__MASK      0x80      

/* PDELCTRL4 */
#define RC8CODEW_DVBSX_PKTDELIN_PDELCTRL4                            0x00000004
#define RC8CODEW_DVBSX_PKTDELIN_PDELCTRL4__DEFAULT                   0x0       
#define FC8CODEW_DVBSX_PKTDELIN_PDELCTRL4_USER_PKTDELIN_NB__MASK     0x07      
#define FC8CODEW_DVBSX_PKTDELIN_PDELCTRL4_PKTDELGSE_CRC32__MASK      0x08      
#define FC8CODEW_DVBSX_PKTDELIN_PDELCTRL4_PKTDEL_CHBONDING__MASK     0x70      
#define FC8CODEW_DVBSX_PKTDELIN_PDELCTRL4_EN_CHBONDING__MASK         0x80      

/* BBHCTRL1 */
#define RC8CODEW_DVBSX_PKTDELIN_BBHCTRL1                             0x00000005
#define RC8CODEW_DVBSX_PKTDELIN_BBHCTRL1__DEFAULT                    0x0       
#define FC8CODEW_DVBSX_PKTDELIN_BBHCTRL1_SYNCD_STREAM__MASK          0x01      
#define FC8CODEW_DVBSX_PKTDELIN_BBHCTRL1_SYNC_STREAM__MASK           0x02      
#define FC8CODEW_DVBSX_PKTDELIN_BBHCTRL1_DFL_STREAM__MASK            0x04      
#define FC8CODEW_DVBSX_PKTDELIN_BBHCTRL1_UPL_STREAM__MASK            0x08      
#define FC8CODEW_DVBSX_PKTDELIN_BBHCTRL1_MATYPE_STREAM__MASK         0x10      
#define FC8CODEW_DVBSX_PKTDELIN_BBHCTRL1_BCHERRFLG_USE__MASK         0x60      
#define FC8CODEW_DVBSX_PKTDELIN_BBHCTRL1_OUT_ENBYPASS__MASK          0x80      

/* BBHCTRL2 */
#define RC8CODEW_DVBSX_PKTDELIN_BBHCTRL2                             0x00000006
#define RC8CODEW_DVBSX_PKTDELIN_BBHCTRL2__DEFAULT                    0x0       
#define FC8CODEW_DVBSX_PKTDELIN_BBHCTRL2_SYNCD_I2C__MASK             0x01      
#define FC8CODEW_DVBSX_PKTDELIN_BBHCTRL2_SYNC_I2C__MASK              0x02      
#define FC8CODEW_DVBSX_PKTDELIN_BBHCTRL2_DFL_I2C__MASK               0x04      
#define FC8CODEW_DVBSX_PKTDELIN_BBHCTRL2_UPL_I2C__MASK               0x08      
#define FC8CODEW_DVBSX_PKTDELIN_BBHCTRL2_MATYPE_I2C__MASK            0x10      
#define FC8CODEW_DVBSX_PKTDELIN_BBHCTRL2_FORCE_MATYPEMSB__MASK       0x20      
#define FC8CODEW_DVBSX_PKTDELIN_BBHCTRL2_TSGS_UPL_DELOCK__MASK       0x40      
#define FC8CODEW_DVBSX_PKTDELIN_BBHCTRL2_IPFRAME_FCSINVERT__MASK     0x80      

/* HYSTTHRESH */
#define RC8CODEW_DVBSX_PKTDELIN_HYSTTHRESH                           0x00000007
#define RC8CODEW_DVBSX_PKTDELIN_HYSTTHRESH__DEFAULT                  0x0       
#define FC8CODEW_DVBSX_PKTDELIN_HYSTTHRESH_DELIN_UNLOCKTHRES__MASK   0x0F      
#define FC8CODEW_DVBSX_PKTDELIN_HYSTTHRESH_DELIN_LOCKTHRES__MASK     0xF0      

/* ISIENTRY */
#define RC8CODEW_DVBSX_PKTDELIN_ISIENTRY                             0x00000008
#define RC8CODEW_DVBSX_PKTDELIN_ISIENTRY__DEFAULT                    0x0       
#define FC8CODEW_DVBSX_PKTDELIN_ISIENTRY_ISI_ENTRY__MASK             0xFF      

/* ISIBITENA */
#define RC8CODEW_DVBSX_PKTDELIN_ISIBITENA                            0x00000009
#define RC8CODEW_DVBSX_PKTDELIN_ISIBITENA__DEFAULT                   0x0       
#define FC8CODEW_DVBSX_PKTDELIN_ISIBITENA_ISI_BIT_EN__MASK           0xFF      

/* PDELDBGM */
#define RC8CODEW_DVBSX_PKTDELIN_PDELDBGM                             0x0000000c
#define RC8CODEW_DVBSX_PKTDELIN_PDELDBGM__DEFAULT                    0x0       
#define FC8CODEW_DVBSX_PKTDELIN_PDELDBGM_T2INBAND_NPLPRST__MASK      0x01      
#define FC8CODEW_DVBSX_PKTDELIN_PDELDBGM_DBGWISE_LGNOFF__MASK        0x02      
#define FC8CODEW_DVBSX_PKTDELIN_PDELDBGM_UPLISCR_CRC8SEL__MASK       0x04      
#define FC8CODEW_DVBSX_PKTDELIN_PDELDBGM_PKTDELIN_GSEFILTRE__MASK    0x08      
#define FC8CODEW_DVBSX_PKTDELIN_PDELDBGM_PKTDELIN_NDLYOV__MASK       0x10      
#define FC8CODEW_DVBSX_PKTDELIN_PDELDBGM_PKTDEL_NMAXSPEED__MASK      0x20      
#define FC8CODEW_DVBSX_PKTDELIN_PDELDBGM_PKTDEL_NOENDBLOC__MASK      0x40      
#define FC8CODEW_DVBSX_PKTDELIN_PDELDBGM_PKTDEL_ISIDEFRAG__MASK      0x80      

/* PDELDBGL */
#define RC8CODEW_DVBSX_PKTDELIN_PDELDBGL                             0x0000000d
#define RC8CODEW_DVBSX_PKTDELIN_PDELDBGL__DEFAULT                    0x0       
#define FC8CODEW_DVBSX_PKTDELIN_PDELDBGL_T2INBAND_DISNPADDNG__MASK   0x01      
#define FC8CODEW_DVBSX_PKTDELIN_PDELDBGL_T2INBAND_DISSTATIC__MASK    0x02      
#define FC8CODEW_DVBSX_PKTDELIN_PDELDBGL_T2INBAND_DISPLOAD__MASK     0x04      
#define FC8CODEW_DVBSX_PKTDELIN_PDELDBGL_T2INBAND_FORCE1ER__MASK     0x08      
#define FC8CODEW_DVBSX_PKTDELIN_PDELDBGL_T2INBAND_NOTTOAECH__MASK    0x10      
#define FC8CODEW_DVBSX_PKTDELIN_PDELDBGL_T2INBAND_NO1ERFRAME__MASK   0x20      
#define FC8CODEW_DVBSX_PKTDELIN_PDELDBGL_T2INBAND_NOVALID__MASK      0x40      
#define FC8CODEW_DVBSX_PKTDELIN_PDELDBGL_T2INBAND_DELFRAME__MASK     0x80      

/* MATCST1 */
#define RC8CODEW_DVBSX_PKTDELIN_MATCST1                              0x00000010
#define RC8CODEW_DVBSX_PKTDELIN_MATCST1__DEFAULT                     0x0       
#define FC8CODEW_DVBSX_PKTDELIN_MATCST1_MATYPECST_ROLLOFF__MASK      0x03      
#define FC8CODEW_DVBSX_PKTDELIN_MATCST1_MATYPECST_NPD__MASK          0x04      
#define FC8CODEW_DVBSX_PKTDELIN_MATCST1_MATYPECST_ISSYI__MASK        0x08      
#define FC8CODEW_DVBSX_PKTDELIN_MATCST1_MATYPECST_CCMACM__MASK       0x10      
#define FC8CODEW_DVBSX_PKTDELIN_MATCST1_MATYPECST_SISMIS__MASK       0x20      
#define FC8CODEW_DVBSX_PKTDELIN_MATCST1_MATYPECST_TSGS__MASK         0xC0      

/* MATCST0 */
#define RC8CODEW_DVBSX_PKTDELIN_MATCST0                              0x00000011
#define RC8CODEW_DVBSX_PKTDELIN_MATCST0__DEFAULT                     0x0       
#define FC8CODEW_DVBSX_PKTDELIN_MATCST0_MATYPECST_ISI__MASK          0xFF      

/* UPLCST1 */
#define RC8CODEW_DVBSX_PKTDELIN_UPLCST1                              0x00000012
#define RC8CODEW_DVBSX_PKTDELIN_UPLCST1__DEFAULT                     0x0       
#define FC8CODEW_DVBSX_PKTDELIN_UPLCST1_UPL_CST__MASK                0xFF      

/* UPLCST0 */
#define RC8CODEW_DVBSX_PKTDELIN_UPLCST0                              0x00000013
#define RC8CODEW_DVBSX_PKTDELIN_UPLCST0__DEFAULT                     0x0       
#define FC8CODEW_DVBSX_PKTDELIN_UPLCST0_UPL_MODE__MASK               0x07      
#define FC8CODEW_DVBSX_PKTDELIN_UPLCST0_UPL_CST__MASK                0xF8      

/* DFLCST1 */
#define RC8CODEW_DVBSX_PKTDELIN_DFLCST1                              0x00000014
#define RC8CODEW_DVBSX_PKTDELIN_DFLCST1__DEFAULT                     0x0       
#define FC8CODEW_DVBSX_PKTDELIN_DFLCST1_DFL_CST__MASK                0xFF      

/* DFLCST0 */
#define RC8CODEW_DVBSX_PKTDELIN_DFLCST0                              0x00000015
#define RC8CODEW_DVBSX_PKTDELIN_DFLCST0__DEFAULT                     0x0       
#define FC8CODEW_DVBSX_PKTDELIN_DFLCST0_DFL_CST__MASK                0xFF      

/* SYNCCST */
#define RC8CODEW_DVBSX_PKTDELIN_SYNCCST                              0x00000016
#define RC8CODEW_DVBSX_PKTDELIN_SYNCCST__DEFAULT                     0x0       
#define FC8CODEW_DVBSX_PKTDELIN_SYNCCST_SYNC_CST__MASK               0xFF      

/* SYNCDCST1 */
#define RC8CODEW_DVBSX_PKTDELIN_SYNCDCST1                            0x00000017
#define RC8CODEW_DVBSX_PKTDELIN_SYNCDCST1__DEFAULT                   0x0       
#define FC8CODEW_DVBSX_PKTDELIN_SYNCDCST1_SYNCD_CST__MASK            0xFF      

/* SYNCDCST0 */
#define RC8CODEW_DVBSX_PKTDELIN_SYNCDCST0                            0x00000018
#define RC8CODEW_DVBSX_PKTDELIN_SYNCDCST0__DEFAULT                   0x0       
#define FC8CODEW_DVBSX_PKTDELIN_SYNCDCST0_SYNCD_CST__MASK            0xFF      

/* MATSTR1 */
#define RC8CODEW_DVBSX_PKTDELIN_MATSTR1                              0x00000020
#define RC8CODEW_DVBSX_PKTDELIN_MATSTR1__DEFAULT                     0x0       
#define FC8CODEW_DVBSX_PKTDELIN_MATSTR1_MATYPE_ROLLOFF__MASK         0x03      
#define FC8CODEW_DVBSX_PKTDELIN_MATSTR1_MATYPE_NPD__MASK             0x04      
#define FC8CODEW_DVBSX_PKTDELIN_MATSTR1_MATYPE_ISSYI__MASK           0x08      
#define FC8CODEW_DVBSX_PKTDELIN_MATSTR1_MATYPE_CCMACM__MASK          0x10      
#define FC8CODEW_DVBSX_PKTDELIN_MATSTR1_MATYPE_SISMIS__MASK          0x20      
#define FC8CODEW_DVBSX_PKTDELIN_MATSTR1_MATYPE_TSGS__MASK            0xC0      

/* MATSTR0 */
#define RC8CODEW_DVBSX_PKTDELIN_MATSTR0                              0x00000021
#define RC8CODEW_DVBSX_PKTDELIN_MATSTR0__DEFAULT                     0x0       
#define FC8CODEW_DVBSX_PKTDELIN_MATSTR0_MATYPEISI_CURRENT__MASK      0xFF      

/* UPLSTR1 */
#define RC8CODEW_DVBSX_PKTDELIN_UPLSTR1                              0x00000022
#define RC8CODEW_DVBSX_PKTDELIN_UPLSTR1__DEFAULT                     0x0       
#define FC8CODEW_DVBSX_PKTDELIN_UPLSTR1_UPL_CURRENT__MASK            0xFF      

/* UPLSTR0 */
#define RC8CODEW_DVBSX_PKTDELIN_UPLSTR0                              0x00000023
#define RC8CODEW_DVBSX_PKTDELIN_UPLSTR0__DEFAULT                     0x0       
#define FC8CODEW_DVBSX_PKTDELIN_UPLSTR0_UPL_CURRENT__MASK            0xFF      

/* DFLSTR1 */
#define RC8CODEW_DVBSX_PKTDELIN_DFLSTR1                              0x00000024
#define RC8CODEW_DVBSX_PKTDELIN_DFLSTR1__DEFAULT                     0x0       
#define FC8CODEW_DVBSX_PKTDELIN_DFLSTR1_DFL_CURRENT__MASK            0xFF      

/* DFLSTR0 */
#define RC8CODEW_DVBSX_PKTDELIN_DFLSTR0                              0x00000025
#define RC8CODEW_DVBSX_PKTDELIN_DFLSTR0__DEFAULT                     0x0       
#define FC8CODEW_DVBSX_PKTDELIN_DFLSTR0_DFL_CURRENT__MASK            0xFF      

/* SYNCSTR */
#define RC8CODEW_DVBSX_PKTDELIN_SYNCSTR                              0x00000026
#define RC8CODEW_DVBSX_PKTDELIN_SYNCSTR__DEFAULT                     0x0       
#define FC8CODEW_DVBSX_PKTDELIN_SYNCSTR_SYNC_CURRENT__MASK           0xFF      

/* SYNCDSTR1 */
#define RC8CODEW_DVBSX_PKTDELIN_SYNCDSTR1                            0x00000027
#define RC8CODEW_DVBSX_PKTDELIN_SYNCDSTR1__DEFAULT                   0x0       
#define FC8CODEW_DVBSX_PKTDELIN_SYNCDSTR1_SYNCD_CURRENT__MASK        0xFF      

/* SYNCDSTR0 */
#define RC8CODEW_DVBSX_PKTDELIN_SYNCDSTR0                            0x00000028
#define RC8CODEW_DVBSX_PKTDELIN_SYNCDSTR0__DEFAULT                   0x0       
#define FC8CODEW_DVBSX_PKTDELIN_SYNCDSTR0_SYNCD_CURRENT__MASK        0xFF      

/* ISIMAXSTR */
#define RC8CODEW_DVBSX_PKTDELIN_ISIMAXSTR                            0x00000029
#define RC8CODEW_DVBSX_PKTDELIN_ISIMAXSTR__DEFAULT                   0x0       
#define FC8CODEW_DVBSX_PKTDELIN_ISIMAXSTR_MATYPE_ISIMAX__MASK        0xFF      

/* ISIMINSTR */
#define RC8CODEW_DVBSX_PKTDELIN_ISIMINSTR                            0x0000002a
#define RC8CODEW_DVBSX_PKTDELIN_ISIMINSTR__DEFAULT                   0x0       
#define FC8CODEW_DVBSX_PKTDELIN_ISIMINSTR_MATYPE_ISIMIN__MASK        0xFF      

/* PDELSTATUS1 */
#define RC8CODEW_DVBSX_PKTDELIN_PDELSTATUS1                          0x00000030
#define RC8CODEW_DVBSX_PKTDELIN_PDELSTATUS1__DEFAULT                 0x0       
#define FC8CODEW_DVBSX_PKTDELIN_PDELSTATUS1_FIRST_LOCK__MASK         0x01      
#define FC8CODEW_DVBSX_PKTDELIN_PDELSTATUS1_PKTDELIN_LOCK__MASK      0x02      
#define FC8CODEW_DVBSX_PKTDELIN_PDELSTATUS1_BBHCRCKO__MASK           0x04      
#define FC8CODEW_DVBSX_PKTDELIN_PDELSTATUS1_BCH_ERROR_FLAG__MASK     0x08      
#define FC8CODEW_DVBSX_PKTDELIN_PDELSTATUS1_UNACCEPTED_STREAM__MASK  0x10      
#define FC8CODEW_DVBSX_PKTDELIN_PDELSTATUS1_CONTINUOUS_STREAM__MASK  0x20      
#define FC8CODEW_DVBSX_PKTDELIN_PDELSTATUS1_SYNCDUPDFL_BADDFL__MASK  0x40      
#define FC8CODEW_DVBSX_PKTDELIN_PDELSTATUS1_PKTDELIN_DELOCK__MASK    0x80      

/* PDELSTATUS2 */
#define RC8CODEW_DVBSX_PKTDELIN_PDELSTATUS2                          0x00000031
#define RC8CODEW_DVBSX_PKTDELIN_PDELSTATUS2__DEFAULT                 0x0       
#define FC8CODEW_DVBSX_PKTDELIN_PDELSTATUS2_FRAME_TYPE__MASK         0x03      
#define FC8CODEW_DVBSX_PKTDELIN_PDELSTATUS2_FRAME_MODCOD__MASK       0xFC      

/* PDELSTATUS3 */
#define RC8CODEW_DVBSX_PKTDELIN_PDELSTATUS3                          0x00000032
#define RC8CODEW_DVBSX_PKTDELIN_PDELSTATUS3__DEFAULT                 0x0       
#define FC8CODEW_DVBSX_PKTDELIN_PDELSTATUS3_PKTDELIN_GSETYPE__MASK   0x0F      
#define FC8CODEW_DVBSX_PKTDELIN_PDELSTATUS3_TS_NOCRC8BYTE__MASK      0x10      
#define FC8CODEW_DVBSX_PKTDELIN_PDELSTATUS3_PKTDEL_DEMODSEL__MASK    0x20      
#define FC8CODEW_DVBSX_PKTDELIN_PDELSTATUS3_GSELITE_DETECT__MASK     0x40      
#define FC8CODEW_DVBSX_PKTDELIN_PDELSTATUS3_XXXCRCKO_LOCK__MASK      0x80      

/* BBFCRCKO1 */
#define RC8CODEW_DVBSX_PKTDELIN_BBFCRCKO1                            0x00000034
#define RC8CODEW_DVBSX_PKTDELIN_BBFCRCKO1__DEFAULT                   0x0       
#define FC8CODEW_DVBSX_PKTDELIN_BBFCRCKO1_BBHCRC_KOCNT__MASK         0xFF      

/* BBFCRCKO0 */
#define RC8CODEW_DVBSX_PKTDELIN_BBFCRCKO0                            0x00000035
#define RC8CODEW_DVBSX_PKTDELIN_BBFCRCKO0__DEFAULT                   0x0       
#define FC8CODEW_DVBSX_PKTDELIN_BBFCRCKO0_BBHCRC_KOCNT__MASK         0xFF      

/* UPCRCKO1 */
#define RC8CODEW_DVBSX_PKTDELIN_UPCRCKO1                             0x00000036
#define RC8CODEW_DVBSX_PKTDELIN_UPCRCKO1__DEFAULT                    0x0       
#define FC8CODEW_DVBSX_PKTDELIN_UPCRCKO1_PKTCRC_KOCNT__MASK          0xFF      

/* UPCRCKO0 */
#define RC8CODEW_DVBSX_PKTDELIN_UPCRCKO0                             0x00000037
#define RC8CODEW_DVBSX_PKTDELIN_UPCRCKO0__DEFAULT                    0x0       
#define FC8CODEW_DVBSX_PKTDELIN_UPCRCKO0_PKTCRC_KOCNT__MASK          0xFF      

/* TPKTDELIN */
#define RC8CODEW_DVBSX_PKTDELIN_TPKTDELIN                            0x0000003f
#define RC8CODEW_DVBSX_PKTDELIN_TPKTDELIN__DEFAULT                   0x0       
#define FC8CODEW_DVBSX_PKTDELIN_TPKTDELIN_TESTBUS_SELECT__MASK       0x0F      
#define FC8CODEW_DVBSX_PKTDELIN_TPKTDELIN_DISPDEL_CLKENABLE__MASK    0x10      
#define FC8CODEW_DVBSX_PKTDELIN_TPKTDELIN_PKTDEL_NOMISCONT__MASK     0x20      
#define FC8CODEW_DVBSX_PKTDELIN_TPKTDELIN_DIS_BBHCHECK__MASK         0x40      
#define FC8CODEW_DVBSX_PKTDELIN_TPKTDELIN_DIS_SLICEINC__MASK         0x80      


/* Number of registers */
#define C8CODEW_DVBSX_PKTDELIN_REG_NBREGS                            40        

/* Number of fields */
#define C8CODEW_DVBSX_PKTDELIN_REG_NBFIELDS                          123       



#endif /* #ifndef _DVBSX_PKTDELIN_REG_INIT_H */
