#include <stdlib.h>
#include <stdio.h>
#include <stdint.h>
#include <inttypes.h>
#include <sys/ioctl.h>
#include <string.h>
#include <errno.h>


#include "tbsecp3-spi.h"


unsigned char spi_CheckFree(unsigned char OpbyteNum)
{
	unsigned char tmpbuf[4];
	int i;
	int j=500;
	if(OpbyteNum==2)
		j=400;
	else if(OpbyteNum==1)
		j=200;	
	//usleep(1);
	tmpbuf[0] = 0;
	for(i=0;(i<j) && (tmpbuf[0] != 1);i++)
	{
		//*(u32 *)tmpbuf = tbs_read(GPIO_BASEADDRESS , SPI_STATUS );
		*(u32 *)tmpbuf=tbs_read(SPI_STATUS);

	}
	//return (tmpbuf[0] == 1);

	if(tmpbuf[0] == 1)
		return true;
	else
	{
		printf("----------spi flash check error! %x, %x, %x, %x\n",tmpbuf[0], tmpbuf[1],tmpbuf[2],tmpbuf[3]);
		return false;
	} 
}

void spi_WriteEnable()
{
	unsigned char tmpbuf[4];

	//write enable:
	tmpbuf[0] = 0x06;  
	tbs_write( SPI_COMMAND , *(u32 *)&tmpbuf[0]);
	tmpbuf[0] = 0xe0;
	tmpbuf[1] = 0x10;
	tbs_write( SPI_CONFIG  , *(u32 *)&tmpbuf[0]);
	if(spi_CheckFree(1)== false)
	{
		printf(" spi_WriteEnable error!\n");
		return;	
	}

	return;
}


void spi_WriteDisable()
{
	unsigned char tmpbuf[4];

	//write disable:
	tmpbuf[0] = 0x04;  
	tbs_write( SPI_COMMAND , *(u32 *)&tmpbuf[0]);
	
	tmpbuf[0] = 0xe0;
	tmpbuf[1] = 0x10;
	tbs_write( SPI_CONFIG , *(u32 *)&tmpbuf[0]);
	
	//spi_CheckFree(1);
	if(spi_CheckFree(1)== false)
	{
		printf(" spi_WriteDisable error!\n");
		return;	
	}

	return;
}


unsigned char spi_GetFlashID(unsigned char *flashID)
{
	unsigned char i;
	unsigned char tmpbuf[4]={0};
	unsigned char tmpreg[4]={0};
	
	tmpbuf[0] = 1; //choose spi device for fpga
	tbs_write( SPI_DEVICE , *(u32 *)&tmpbuf[0]);

	tmpbuf[0] = 1; //active spi bus from "z"
	tbs_write( SPI_ENABLE , *(u32 *)&tmpbuf[0]);

	//release from Deep Power-down mode:
	tmpbuf[0] = 0xab;  
	tbs_write( SPI_COMMAND  , *(u32 *)&tmpbuf[0]);
	tmpbuf[0] = 0xe0;
	tmpbuf[1] = 0x10;
	tbs_write( SPI_CONFIG , *(u32 *)&tmpbuf[0]);
	//spi_CheckFree(1);
	if(spi_CheckFree(1)== false)
	{
		printf(" spi_GetFlashID error 00 !\n");
		return 0;	
	}


	tmpbuf[0] = 0x9f;  //write one byte "read identification command" ;
	tbs_write( SPI_COMMAND ,*(u32 *)&tmpbuf[0]);
	

	tmpbuf[0] = 0x80;	//cs high to low;
	tmpbuf[0] += 0x40;  //cs low to high;
	tmpbuf[0] += 0x20;  //write command;
	tmpbuf[0] += 0x10;  // read 3 bytes ID
	
	tmpbuf[1] = 0x10;   //just one byte command for writing;
	tmpbuf[1] += 0x03;   //read 3 bytes ID;
	tbs_write( SPI_CONFIG ,*(u32 *)&tmpbuf[0]);
	
	if(spi_CheckFree(1)== false)
	{
		printf(" spi read ID error!\n");
		return 0;	
	}
	*(u32 *)tmpbuf = tbs_read(SPI_RD_DATA );
	for(i=0;i<3;i++)
	{
		flashID[i] = tmpbuf[i];
		//printf("ID:0x%x\n",tmpbuf[i]);
	}

// 20170110 add
	*(u32 *)tmpbuf = tbs_read( GPIO_VERSION); 
	for(i=0;i<4;i++)
	{
		flashID[i+3] = tmpbuf[i];
		printf("version:0x%x\n",tmpbuf[i]);
	}
	
//190509
	/*
	//5862 call 
	Max5862ReadnBytes( 2, 0x000, tmpbuf);

	tmpbuf[0] = 0x10;
	tmpbuf[1] = 0x4e;
	Max5862WritenBytes(2,0x500,tmpbuf);
	Max5862ReadnBytes( 2, 0x500, tmpbuf);
	printf("velue: %x , %x !\n", tmpbuf[0],tmpbuf[1]);
	*/

/*
	//9789 call to write and read
	//first need to choose spi device for 9789
	tmpbuf[0] = 0;
	tbs_write(SPI_DEVICE, *(u32 *)&tmpbuf[0]);

	tmpbuf[0] = 0x12;
	ad9789_wt_nBytes(1, 0x3d, tmpbuf);

	ad9789_rd_nBytes( 1, 0x3d, tmpbuf);
	printf("test 9789 read velue: %x ,\n", tmpbuf[0]);


	//I2c call to write and read

	tmpbuf[0] = 0x3f;  //bit28-31
	tmpbuf[1] = 0xb3;
	tmpbuf[2] = 0xb2;  
	tmpbuf[3] = 0xb1;  //bit0--7

	tmpreg[0]= 0x12;
	tmpreg[1]= 0x00;
	i2c_write(0x46,tmpreg,4,tmpbuf);

	tmpreg[0]= 0x12;
	tmpreg[1]= 0x00;
	i2c_read_no_stop(0x46,tmpreg,2,tmpbuf,4);
	printf("test IIc r and w: %x%x%x%x !\n", tmpbuf[0],tmpbuf[1],tmpbuf[2],tmpbuf[3]);

*/




	*(u32 *)tmpbuf = tbs_read( GPIO_FPGA); 
	printf("fpga data:%x%x-%x-%x\n",tmpbuf[0],tmpbuf[1],tmpbuf[2],tmpbuf[3]);

	//check flash id
	if((flashID[0]==0xc2)&&(flashID[1]==0x20)&&(flashID[2]==0x16))
		return 1;
	else if((flashID[0]==0xef)&&(flashID[1]==0x40)&&(flashID[2]==0x16))
		return 1;
	else 
	{
		printf("flashID:%x-%x-%x\n",flashID[0],flashID[1],flashID[2]);
		return 0;
	}
}



unsigned char spi_ChipErase()
{
	unsigned char i, wip, tmpbuf[4];

	spi_WriteEnable();

	//Chip Erase:
	tmpbuf[0] = 0xc7;  
	tbs_write( SPI_COMMAND  , *(u32 *)&tmpbuf[0]);
	tmpbuf[0] = 0xe0;
	tmpbuf[1] = 0x10;
	tbs_write( SPI_CONFIG  , *(u32 *)&tmpbuf[0]);
	usleep(1000);

	return 1;
}

unsigned char spi_ChipEraseStatus()
{
	unsigned char wip, tmpbuf[4];

	//read status register for WIP bit;	
	tmpbuf[0] = 0x05;  
	tbs_write( SPI_COMMAND , *(u32 *)&tmpbuf[0]);
	tmpbuf[0] = 0xf0;
	tmpbuf[1] = 0x11;
	tbs_write( SPI_CONFIG , *(u32 *)&tmpbuf[0]);
	usleep(2000);
	
	*(u32 *)tmpbuf = tbs_read(SPI_RD_DATA );  
	printf("read status register: %x\n",tmpbuf[0]);
	wip = tmpbuf[0]&1;
	
	if(wip==0)
		return 1;
	else
		return 0;
}


bool spi_read32bit(unsigned char * addr24bit, u32 *data32bit)
{
	unsigned char i, tmpbuf[4];

	tmpbuf[0] = 0x03;  // read command ;
	tmpbuf[1] = addr24bit[0]; //read_address, msb first;
	tmpbuf[2] = addr24bit[1];
	tmpbuf[3] = addr24bit[2];
	tbs_write( SPI_COMMAND , *(u32 *)&tmpbuf[0]);
	
	tmpbuf[0] = 0xf0;	//cs low,cs high, write, read;	
	tmpbuf[1] = 0x40;	// 4 bytes command for writing;
  tmpbuf[1] += 0x04;	 //read 4 bytes data;
	tbs_write(  SPI_CONFIG  , *(u32 *)&tmpbuf[0]);

	if(spi_CheckFree(2)== false)
	{
		printf(" spi_read32bit error!\n");
		return false;	
	}

	*data32bit = tbs_read( SPI_RD_DATA ); 

	return true;
}

bool spi_read1page(unsigned char * addr24bit, unsigned char *data256bytes)
{
	unsigned char i, tmpbuf[4];
	u32 addressTemp =*(u32 *)addr24bit;
	
	for(i=0;i<64;i++)
	{
		
		*(u32 *)addr24bit = addressTemp + i*4;
		
		tmpbuf[0] = 0x03;  // read command ;
		tmpbuf[1] = addr24bit[0]; //read_address, msb first;
		tmpbuf[2] = addr24bit[1];
		tmpbuf[3] = addr24bit[2];
		tbs_write( SPI_COMMAND , *(u32 *)&tmpbuf[0]);
	
		tmpbuf[0] = 0xf0;	//cs low,cs high, write, read;	
		tmpbuf[1] = 0x40;	// 4 bytes command for writing;
   		tmpbuf[1] += 0x04;	 //read 4 bytes data;
		tbs_write( SPI_CONFIG , *(u32 *)&tmpbuf[0]);

	if(spi_CheckFree(2)== false)
	{
		printf(" spi_read32bit error!\n");
		return false;	
	}

	*(u32*)&data256bytes[i*4] = tbs_read( SPI_RD_DATA); 

	printf(" spi_read1page addr: %x\n  ( %6x)", *(u32 *)addr24bit,*(u32*)&data256bytes[i*4]);




	usleep(1000);
	

	}
	return true;
}


bool spi_Write32bit(unsigned char * addr24bit, u32 *data32bit)
{
	unsigned char i, wip, tmpbuf[4];

	tmpbuf[0] = 0x02;  // PP;
	tmpbuf[1] = addr24bit[0]; //read_address, msb first;
	tmpbuf[2] = addr24bit[1];
	tmpbuf[3] = addr24bit[2];
	tbs_write( SPI_COMMAND , *(u32 *)&tmpbuf[0]);

	tbs_write( SPI_WT_DATA  , *data32bit);

	tmpbuf[0] = 0xe0;	//cs low,cs high, write, no read;	
	tmpbuf[1] = 0x80;	// 4 bytes command & 2 bytes data for writing;
	tbs_write( SPI_CONFIG, *(u32 *)&tmpbuf[0]);
	if(spi_CheckFree(2)== false)
	{
		printf(" spi_Write32bit 1 error!\n");
		return false;	
	}

	//read status register for WIP bit;
	wip = 1;
	for(i=0;(i<50)&wip;i++)
	{
		usleep(1000);  //delay one second;
		
		tmpbuf[0] = 0x05;  
		tbs_write( SPI_COMMAND , *(u32 *)&tmpbuf[0]);
		tmpbuf[0] = 0xf0;
		tmpbuf[1] = 0x11;
		tbs_write( SPI_CONFIG  , *(u32 *)&tmpbuf[0]);
		if(spi_CheckFree(1)== false)
		{
			printf(" spi_Write32bit 2 error!\n");
			return false;	
		}
		*(u32 *)tmpbuf = tbs_read(  SPI_RD_DATA );  
	
		wip = tmpbuf[0]&1;
	}
	if(i==50)
		printf("write 16 bit-------------------------------------------------------- register: %x\n",tmpbuf[0]);
	return true;
}


bool spi_Write1page(unsigned char * addr24bit, unsigned char *data256byte)
{
	unsigned char i,j, wip, tmpbuf[8];

	spi_WriteEnable();

	tmpbuf[0] = 0x02;  // PP;
	tmpbuf[1] = addr24bit[0]; //read_address, msb first;
	tmpbuf[2] = addr24bit[1];
	tmpbuf[3] = addr24bit[2];
	tbs_write(  SPI_COMMAND, *(u32 *)&tmpbuf[0]);
	tbs_write( SPI_WT_DATA  , *(u32 *)&data256byte[0]);

	tmpbuf[0] = 0xa0;	//cs low,cs high, write, no read;	
	tmpbuf[1] = 0x80;	// 4 bytes command & 2 bytes data for writing;
	tbs_write(  SPI_CONFIG  , *(u32 *)&tmpbuf[0]);
	if(spi_CheckFree(2)== false)
	{
		printf(" spi_Write32bit 1 error!\n");
		return false;	
	}

	for(j=0;j<31;j++)
	{
		tmpbuf[0] = data256byte[4+j*8 +0];
		tmpbuf[1] = data256byte[4+j*8 +1];
		tmpbuf[2] = data256byte[4+j*8 +2];
		tmpbuf[3] = data256byte[4+j*8 +3];
		tmpbuf[4] = data256byte[4+j*8 +4];
		tmpbuf[5] = data256byte[4+j*8 +5];
		tmpbuf[6] = data256byte[4+j*8 +6];
		tmpbuf[7] = data256byte[4+j*8 +7];
		
		tbs_write( SPI_COMMAND , *(u32 *)&tmpbuf[0]);
		tbs_write( SPI_WT_DATA , *(u32 *)&tmpbuf[4]);
		
		tmpbuf[0] = 0x20;	//cs low,cs high, write, no read;	
		tmpbuf[1] = 0x80;	// 4 bytes command & 2 bytes data for writing;
		tbs_write( SPI_CONFIG , *(u32 *)&tmpbuf[0]);
		if(spi_CheckFree(2)== false)
		{
			printf(" spi_Write32bit 1 error!\n");
			return false;	
		}
	}


	tmpbuf[0] = data256byte[252];  
	tmpbuf[1] = data256byte[253];  
	tmpbuf[2] = data256byte[254];  
	tmpbuf[3] = data256byte[255];  
	tbs_write( SPI_COMMAND, *(u32 *)&tmpbuf[0]);

	tmpbuf[0] = 0x60;	//cs low,cs high, write, no read;	
	tmpbuf[1] = 0x40;	// 4 bytes command & 2 bytes data for writing;
	tbs_write( SPI_CONFIG, *(u32 *)&tmpbuf[0]);
	if(spi_CheckFree(2)== false)
	{
		printf(" spi_Write32bit 1 error!\n");
		return false;	
	}

	//read status register for WIP bit;
	wip = 1;
	for(i=0;(i<250)&wip;i++)
	{
		//pauseThread(1);  //delay one second;
		
		tmpbuf[0] = 0x05;  
		tbs_write(  SPI_COMMAND , *(u32 *)&tmpbuf[0]);
		tmpbuf[0] = 0xf0;
		tmpbuf[1] = 0x11;
		tbs_write(  SPI_CONFIG , *(u32 *)&tmpbuf[0]);
		if(spi_CheckFree(1)== false)
		{
			printf(" spi_Write32bit 2 error!\n");
			return false;	
		}
		*(u32 *)tmpbuf = tbs_read( SPI_RD_DATA ) ;  
	
		wip = tmpbuf[0]&1;
	}
	if(i==250)
	{
		printf("write 16 bit-------------------------------------------------------- register: %x\n",tmpbuf[0]);
		return false;
	}
	return true;


}

void spi_EnterDeepPowerDown()
{
	unsigned char tmpbuf[4];
	
	//enter  Deep Power-down mode:
	tmpbuf[0] = 0xb9;  
	tbs_write (SPI_COMMAND , *(u32 *)&tmpbuf[0]);
	tmpbuf[0] = 0xe0;
	tmpbuf[1] = 0x10;
	tbs_write (SPI_CONFIG , *(u32 *)&tmpbuf[0]);
	//spi_CheckFree(1);
	if(spi_CheckFree(1)== false)
	{
		printf(" spi_EnterDeepPowerDown error!\n");
		return ;	
	}

	tmpbuf[0] = 0; //spi disable, enter "z" state;
	tbs_write(SPI_ENABLE, *(u32 *)&tmpbuf[0]);
	return;
}



void tbs_write(u8 address,u32 data)
{
	struct mcu24cxx_info winfo;
	winfo.bassaddr=0;
	winfo.reg=address;
	winfo.data=data;
	//printf("data=0x%x\n",data);
	if( ioctl( i_frontend, FE_ECP3FW_WRITE, &winfo ) < 0 )	
	{
		printf("write eror %s\n ",strerror(errno));
		exit(1);
	}

}


u32 tbs_read(u8 address)
{
	struct mcu24cxx_info rinfo;
	rinfo.bassaddr=0;
	rinfo.reg=address;

	if( ioctl( i_frontend, FE_ECP3FW_READ, &rinfo ) < 0 )		
	{
		//printf("read eror ");
		//exit(1);
	}
	//printf("read data=0x%x\n",rinfo.data);
	return rinfo.data;
}

void tbs_i2c_w(u8 address,u32 data)
{
	struct mcu24cxx_info winfo;
	winfo.bassaddr=0x4000;
	winfo.reg=address;
	winfo.data=data;
	//printf("data=0x%x\n",data);
	if( ioctl( i_frontend, FE_ECP3FW_WRITE, &winfo ) < 0 )	
	{
		//printf("write eror %s\n ",strerror(errno));
		//exit(1);
	}

}
u32 tbs_i2c_r(u8 address)
{
	struct mcu24cxx_info rinfo;
	rinfo.bassaddr=0x4000;
	rinfo.reg=address;

	if( ioctl( i_frontend, FE_ECP3FW_READ, &rinfo ) < 0 )		
	{
		//printf("read eror ");
		//exit(1);
	}
	//printf("read data=0x%x\n",rinfo.data);
	return rinfo.data;
}

 bool Max5862CheckFree(int OpbyteNum)
{
	unsigned char tmpbuf[4] = { 0 };
	int i, j;

	if (OpbyteNum > 2)
		j = 100;
	else
		j = 50;
	usleep(1);

	for (i = 0; (i < j) && (tmpbuf[0] != 1); i++)
	{
		*(u32 *)tmpbuf = tbs_read((0+MAX5862_W));
		usleep(1);
	}
	if (tmpbuf[0] == 1)
	{
		printf( "----------Max5862CheckFree times: %d,buf: %d,%d,%d,%d \n",i,tmpbuf[0],tmpbuf[1],tmpbuf[2],tmpbuf[3]);
		return true;
	}
	else
	{
		printf("----------Max5862CheckFree error, time out! buf: %d,%d,%d,%d\n",tmpbuf[0],tmpbuf[1],tmpbuf[2],tmpbuf[3]);
		return false;
	}
}
 bool Max5862WritenBytes( int length, int Reg_Addr, unsigned char *Wr_buf)
 {
	 unsigned char i = 0, tmpdt = 0, tmpbuf[8];
	
	// KeWaitForMutexObject(&pModDev->m_DeviceMutex, Executive, KernelMode, false, NULL);
	 
	 //Reg_Addr 12bit;
	 tmpbuf[0] = ((Reg_Addr >> 7) & 0x1f); // bit4-0 (A11--A7)	bit6-5:null
	 tmpbuf[1] = ((Reg_Addr<<1) & 0xfe);  // bit7--1 (A6-A0) bit0:IDLE	 


	 for (i = 0; i < length; i++)
		 tmpbuf[2 + i] = Wr_buf[i];

	 tbs_write((0+MAX5862_W), *(u32 *)&tmpbuf[0]);

	 if (Max5862CheckFree( 4) == 0)
	 {
		// KeReleaseMutex(&pModDev->m_DeviceMutex, false);
		 printf(" ad9789_wt_nBytes error!	\n");
		 return false;
	 }

	// KeReleaseMutex(&pModDev->m_DeviceMutex, false);
	 return true;
 }

 bool Max5862ReadnBytes(int length, int Reg_Addr, unsigned char *Rd_buf)
  {
	  unsigned char tmpdt = 0, tmpbuf[4];
	//  KeWaitForMutexObject(&pModDev->m_DeviceMutex, Executive, KernelMode, false, NULL);

	
 	tmpdt = 0x20; //bit29 for w and r bit
	
	tmpbuf[0] = ((Reg_Addr >> 7) & 0x1f); // bit4-0 (A11--A7)  bit6-5:null
	tmpbuf[1] = ((Reg_Addr<<1) & 0xfe);  // bit7--1 (A6-A0) bit0:IDLE	
	tmpbuf[0] += tmpdt; //read mark 
	
 
	  tbs_write((0+MAX5862_W), *(u32 *)&tmpbuf[0]);
	  
	  if (Max5862CheckFree( 4) == 0)
	  {
		  printf( " ad9789_rd_nBytes error!   \n");
		 // KeReleaseMutex(&pModDev->m_DeviceMutex, false);
		  return false;
	  }
 
	  *(u32 *)Rd_buf = tbs_read(0+MAX5862_R);

	  
	  printf("Max5862ReadnBytes: %x %x %x %x!\n", Rd_buf[0],Rd_buf[1],Rd_buf[2],Rd_buf[3]);

	  usleep(1);
 
	//  KeReleaseMutex(&pModDev->m_DeviceMutex, false);
	  return true;
  }

bool ad9789_CheckFree(int OpbyteNum)
{
	unsigned char tmpbuf[4] = {0};
	int i, j;

	if (OpbyteNum > 2)
		j = 100;
	else
		j = 50;
	usleep(1);

	for (i = 0; (i < j) && (tmpbuf[0] != 1); i++)
	{
		*(u32 *)tmpbuf = tbs_read( SPI_STATUS);
		usleep(1);
	}
	if (tmpbuf[0] == 1)
		return true;
	else
	{
		printf("ad9789_CheckFree error, time out! \n");
		return false;
	}
}

bool ad9789_wt_nBytes(int length, int Reg_Addr, unsigned char *Wr_buf)
{
	unsigned char i = 0, tmpdt = 0, tmpbuf[8];
	//mutex_lock(&dev->spi_mutex);

	if (length == 3)
		tmpdt = 0x40;
	else if (length == 2)
		tmpdt = 0x20;
	else if (length == 1)
		tmpdt = 0x00;
	else
		printf(" ad9789_wt_nBytes error length !\n");

	//Reg_Addr 13bit;
	tmpbuf[0] = ((Reg_Addr >> 8) & 0x1f);
	tmpbuf[1] = (Reg_Addr & 0xff);
	tmpbuf[0] += tmpdt; //3'b0xx; write;

	for (i = 0; i < length; i++)
		tmpbuf[2 + i] = Wr_buf[i];

	tbs_write(SPI_COMMAND, *(u32 *)&tmpbuf[0]);
	tbs_write(SPI_WT_DATA, *(u32 *)&tmpbuf[4]);

	tmpbuf[0] = 0xe0; //cs low,cs high, write, no read;
	tmpbuf[1] = 0;
	tmpbuf[1] += (length + 2) * 16; // regadd + length
	tbs_write(SPI_CONFIG, *(u32 *)&tmpbuf[0]);

	if (ad9789_CheckFree( 4) == 0)
	{	
		//mutex_unlock(&dev->spi_mutex);
		printf(" ad9789_wt_nBytes error!\n");
		return false;
	}
	
	//mutex_unlock(&dev->spi_mutex);
	return true;
}

bool ad9789_rd_nBytes(int length, int Reg_Addr, unsigned char *Rd_buf)
{
	unsigned char tmpdt = 0, tmpbuf[4];
	//mutex_lock(&dev->spi_mutex);

	if (length == 3)
		tmpdt = 0xc0;
	else if (length == 2)
		tmpdt = 0xa0;
	else if (length == 1)
		tmpdt = 0x80;
	else
		printf(" ad9789_rd_nBytes error length!\n");

	//Reg_Addr 13bit;
	tmpbuf[0] = ((Reg_Addr >> 8) & 0x1f);
	tmpbuf[1] = (Reg_Addr & 0xff);
	tmpbuf[0] += tmpdt; //3'b1xx; read;

	tbs_write( SPI_COMMAND, *(u32 *)&tmpbuf[0]);

	tmpbuf[0] = 0xf0;	//cs low,cs high, write, read;
	tmpbuf[1] = 0x20;	// 2 bytes command for writing;
	tmpbuf[1] += length; //read n bytes data;
	tbs_write(SPI_CONFIG, *(u32 *)&tmpbuf[0]);

	if (ad9789_CheckFree( 4) == 0)
	{
		printf(" ad9789_rd_nBytes error!   \n");
		//mutex_unlock(&dev->spi_mutex);
		return false;
	}

	*(u32 *)Rd_buf = tbs_read( SPI_RD_DATA);

	usleep(1);
	//mutex_unlock(&dev->spi_mutex);
	return true;
}

 bool Check_I2c_Free( u32  bytes_to_transfer)
 {	 
	 unsigned char tmpbuf[4] = { 0 };
	 int i, j;
	 
	 if (bytes_to_transfer > 2)
		 j = 200;
	 else
		 j = 100;
	 usleep(1);

	 *(u32 *)tmpbuf = tbs_i2c_r( 0x00 ); //clear isr
	 
	 for (i = 0; (i < j) && (tmpbuf[0] != 1); i++)
	 {
 		 *(u32 *)tmpbuf = tbs_i2c_r( 0x0c );
		 usleep(1);
	 }
	 if (tmpbuf[0] == 1)
	 {
		//printf("0x400c IIC_CheckFree ok, times: %d!\n",i);
 		 return true;
	 }
	 else
	 {		 
		 printf("0x400c IIC_CheckFree error! \n");
		 return false;
	 }

		  
 }
bool i2c_write( unsigned char chipaddr,unsigned char*subaddr,u32 number,unsigned char *databuff)
 {
	 unsigned char tmpbuf[8];
	 u32 i,finishbyte;
	 
 
	 finishbyte = number+2; //two byte address
 
	 tmpbuf[0] = (0x80 + (unsigned char)finishbyte);
	 tmpbuf[1] = chipaddr;
	 tmpbuf[1] &= 0xfe; 
	 tmpbuf[2] =subaddr[0];
	 tmpbuf[3] =subaddr[1];
	 
	 if(number<7)
		 tmpbuf[0] |= 0x40;    //add stop	 
	 for(i=0;i<number;i++)
		 tmpbuf[4+i] = databuff[i];//check

	Check_I2c_Free(number);
	tbs_i2c_w( ( I2C_W_DATA ), *(u32 *)&tmpbuf[4]);
	tbs_i2c_w(( I2C_COMMAND ), *(u32 *)&tmpbuf[0]);
	if(Check_I2c_Free( number)== false){
		 printf(" write error! subaddr : %x\n",databuff[0]);
		 return 0;
	}
 
	return 1;//i2c_error;
 }
bool i2c_read_no_stop( unsigned char chipaddr,unsigned char*subaddr,unsigned char subsize,unsigned char*databuff,unsigned char rd_lenth)
 {
	 unsigned char tmpbuf[4],rbtmpbuf[4];
	 u32 i;
	 unsigned char finishbyte;
 
	 tmpbuf[0] = 0xa2;

	 tmpbuf[1] = chipaddr;
	 tmpbuf[1] &= 0xfe; 
	tmpbuf[2] =subaddr[0];
	tmpbuf[3] =subaddr[1];
	// tmpbuf[2] =0x40;
	// tmpbuf[3] =0x00;
	
	 Check_I2c_Free( rd_lenth);
	 tbs_i2c_w(( I2C_COMMAND ), *(u32 *)&tmpbuf[0]);
	 if(Check_I2c_Free( 4)== false)
	 {
	 	printf(" read error! Check_I2c_Free!!!!\n");
		 return 0;

	 }
			 
	 finishbyte = 4;
 
	 tmpbuf[0] = 0xe4;	 //start ;
	 tmpbuf[1] = chipaddr;
	 tmpbuf[1] &= 0xfe;
	 tmpbuf[1] += 1;  //read operation;
	 tmpbuf[2] =subaddr[0];
	 tmpbuf[3] =subaddr[1];
	 // tmpbuf[2] =0x40;
	 // tmpbuf[3] =0x00;

	 
	 if(rd_lenth == 0){
		 printf(" error! read register length is zero !\n");
		 return 0;	//error!
	 }

	 tbs_i2c_w(( I2C_COMMAND ), *(u32 *)&tmpbuf[0]);
	 if(Check_I2c_Free(finishbyte+2)== false){
		 printf(" read error! subaddr : %x\n",subaddr[0]);
		 return 0;	  //error.
	 }
 
	 *(u32 *)rbtmpbuf = tbs_i2c_r( I2C_R_DATA );  
	 for(i=0;i<finishbyte;i++)
	{
		databuff[i] = rbtmpbuf[i];
		 //printf(" read buffer : %x\n",rbtmpbuf[i]);
	 }

	 return 1;
 }

/*



*/



