
#include <stdbool.h>
#include <unistd.h>
#include "frontend.h"

//spi flash
#define SPI_CONFIG      	 0x10
#define SPI_STATUS      	 0x10
#define SPI_COMMAND     	 0x14
#define SPI_WT_DATA     	 0x18
#define SPI_RD_DATA     	 0x1c
#define SPI_ENABLE       	 0x1c
#define SPI_DEVICE       	 0x20
#define GPIO_VERSION       0x20
#define GPIO_FPGA       0x28

#define MAX5862_W	 0x48   
#define MAX5862_R	 0x4C

#define I2C_STATUS     	 0x00
#define I2C_COMMAND    	 0x00
#define I2C_W_DATA     	 0x04
#define I2C_R_DATA     	 0x04
#define I2C_SPEED        0x08  

#define I2C0_BASEADDRESS  0x4000
#define I2C1_BASEADDRESS  0x5000

typedef unsigned char u8;
typedef unsigned int u32; 

extern int  i_frontend;

/*typedef struct ecp3_info
{
	u8 reg;
	u32 data;
} ecp3_info;
*/

unsigned char spi_CheckFree(unsigned char OpbyteNum);
void spi_WriteEnable();
void spi_WriteDisable();
unsigned char spi_GetFlashID(unsigned char *flashID);
unsigned char spi_ChipErase();
unsigned char spi_ChipEraseStatus();
bool spi_read32bit(unsigned char * addr24bit, u32 *data32bit);
bool spi_read1page(unsigned char * addr24bit, unsigned char *data256bytes);
bool spi_Write32bit(unsigned char * addr24bit, u32 *data32bit);
bool spi_Write1page(unsigned char * addr24bit, unsigned char *data256byte);
void spi_EnterDeepPowerDown();

void tbs_write(u8 address,u32 data);
u32 tbs_read(u8 address);
bool Max5862ReadnBytes(int length, int Reg_Addr, unsigned char *Rd_buf);

bool Max5862WritenBytes( int length, int Reg_Addr, unsigned char *Wr_buf);
bool i2c_write( unsigned char chipaddr,unsigned char*subaddr,u32 number,unsigned char *databuff);
bool i2c_read_no_stop( unsigned char chipaddr,unsigned char*subaddr,unsigned char subsize,unsigned char*databuff,unsigned char rd_lenth);
bool ad9789_rd_nBytes(int length, int Reg_Addr, unsigned char *Rd_buf);
bool ad9789_wt_nBytes(int length, int Reg_Addr, unsigned char *Wr_buf);


bool wrReg32_Extern(u32 baseaddr,u8 address,u32 data);
u32  rdReg32_Extern(u32 baseaddr, u8 address);
bool lin_tbs_24cxx_wr(u32 baseaddr,u8 address,u32 data);
u32  lin_tbs_24cxx_rd(u32 baseaddr, u8 address);
