#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <errno.h>
#include <dirent.h>  
#include <sys/stat.h>  
#include <unistd.h>  
#include <sys/types.h> 
#include <regex.h>
#include <getopt.h>
#include <fcntl.h>
#include <math.h>


char *trim(char* str)
{
	if (str == NULL || *str == '\0')
	{
		return str;
	}
	char *start = str;

	int i=0;
	while (isspace(*start) && *start)
	{
		++start;
		++i;
	}
	int len = strlen(str);
	char *end = str + len -1;

	while (*end && isspace(*end)){
		*end = '\0';
		--end;
	}
	memmove(str, start, strlen(str) - i + 1);
	return str;
}

void delChar(char *str)
{
    int i, j = 0, mark = 0;
    int len = strlen(str);
 
    for(i = 0; i < len; i++)
    {
        if(str[i] == '\"')
        {
			mark++;
			continue;
        }
		if(mark == 1) {
			str[j] = str[i];
			j++;
		}
    }
	str[j] = '\0';
}

int main(int argc,char **argv)
{

	FILE *fd1 = NULL, *fd2 = NULL, *fd3 = NULL;

	char *tmp0 = NULL, *tmp1 = NULL;
	char *tmp_str0 = NULL,*tmp_str1 = NULL;

	int LayerN = 0;
	char str1[512] = { 0 };
	char str2[512] = { 0 };
	char str3[512] = { 0 };
	char value1[50] = { 0 };
	char value2[50] = { 0 };
	char value3[50] = { 0 };
	char value4[50] = { 0 };
	char value5[50] = { 0 };
	char value6[50] = { 0 };
	char Bitrate[50] = { 0 };

	char PIDFB[30] = { 0 };

	sprintf(PIDFB,"./TMCCP/PIDFilter%s",argv[1]);
	//printf("PIDFB = %s\n",PIDFB);

	fd1 = fopen("./TMCCP/PIDF","rb");
	fd2 = fopen("./TMCCP/PIDBitrate","rb");
	fd3 = fopen(PIDFB,"wb");
	if(fd1 == NULL || fd2 == NULL || fd3 == NULL) {
		exit(1);
	}

	sprintf(str1,"{\n");
	fputs(str1,fd3);
	sprintf(str1,"\"Channel\":	\"%s\",\n",argv[1]);
	fputs(str1,fd3);
	sprintf(str1,"\"Table\":	[");
	fputs(str1,fd3);

	while(!feof(fd1)) {
		memset(str1,0,sizeof(str1));
		fgets(str1,sizeof(str1),fd1);
		if(str1[0] == '\n' || str1[0] == '\r' || str1[0] == '\0') {
			continue;
		}
		else if(0 == strncmp(str1,"{", 1) || 0 == strncmp(str1,"},{", 3)) {
			fputs(str1,fd3);
			continue;
		}
		else if(2 == strlen(str1) && 0 == strncmp(str1,"},", 3)) {
			sprintf(str1,"}");
			fputs(str1,fd3);
		}
		else {
			strcpy(str2,str1);
			tmp0 = strtok(str2, ":");
			tmp1 = strtok(NULL, ":");

			if(tmp0 == NULL || tmp1 == NULL)
			{	
				//printf("Please write the configuration file in the correct format\n");
				continue;
			}

			tmp_str0 = trim(tmp0);
			tmp_str1 = trim(tmp1);
			strcpy(value1,tmp_str1);
			delChar(value1);
			if(0 == strncmp(tmp_str0, "\"Layer\"", 7)) {
				LayerN++;
				if(LayerN > 30)
				{
					sprintf(str1,"	\"Layer\":	\"B\",\n");
				}
				if(LayerN > 60)
				{
					sprintf(str1,"	\"Layer\":	\"C\",\n");
				}
			}
			if(0 == strncmp(tmp_str0, "\"PID\"", 5)) {
				//printf("tmp_str0=%s value1=%s\n\n", tmp_str0, value1);

				while(fgets(str3,sizeof(str3),fd2)) {
					sscanf(str3,"%s %s %s %s %s",value2, value3, value4, value5, value6);
					if(0 == strcmp(value1,value2)) {
						strcpy(Bitrate,value6);
						//printf("tmp_str0=%s value1=%s value2=%s value6=%s\n\n", tmp_str0, value1,value2,value6);
					}
				}
    			rewind(fd2);
			}
			if(0 == strncmp(tmp_str0, "\"Bitrate\"", 9)) {
				sprintf(str1,"	%s:	\"%s\"\n",tmp_str0,Bitrate);
			}
			fputs(str1,fd3);
		}
	}

	sprintf(str1,"]\n");
	fputs(str1,fd3);
	sprintf(str1,"}");
	fputs(str1,fd3);

	return 0;
}
