/* This file is released into the public domain by its authors */

#include <stdio.h>
#include <stdlib.h>
#include <sys/ioctl.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <time.h>
#include <sys/poll.h>
#include <sys/time.h>
#include <string.h>
#include <limits.h>
#include <stdbool.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <sys/uio.h>
#include <sys/poll.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <net/if.h>
#include <arpa/inet.h>
#include <errno.h>
#include <netdb.h>
#include <netinet/udp.h>
#include <netinet/ip.h>



#define BSIZE 188

static int pidt[0x2001];

static void usage()
{
	printf("Usage:: ./calc -i 127.0.0.1 -p 1234 \n");
}

int main(int argc, char **argv)
{
	struct timeval startt;
	char *serverip = 0;
	int port = 0;
	char *search = NULL;
	int fd, ffd, packets = 0;
	int opt;

	int i_handle;
    int i=1;
    int i_family=AF_INET;
    int flag=0;

	

	while ((opt = getopt(argc, argv, "i:p:s:h")) != -1) {
		switch (opt) {
		case 'i':
			serverip = strdup(optarg);
			break;
		case 'p':
			port = atoi(optarg);
			break;			
		case 'h':
			usage(stdout);
			exit(0);
		case 's':
			search = strdup(optarg);
			break;
		default:
			usage();
			exit(1);
		}
	}

	if(argc == 1){
		usage();
		exit(1);
	}		

    if ( (i_handle = socket( i_family, SOCK_DGRAM, IPPROTO_UDP )) < 0 ){
        printf("couldn't create socket (%s)", strerror(errno) );
        exit(EXIT_FAILURE);
    }
  	setsockopt( i_handle, SOL_SOCKET, SO_REUSEADDR, (void *) &i, sizeof( i ) );
    i = 0x80000;
    
    setsockopt( i_handle, SOL_SOCKET, SO_RCVBUF, (void *) &i, sizeof( i ) );

	struct timeval timeout = {3,0};//{s,us}
	setsockopt(i_handle, SOL_SOCKET, SO_RCVTIMEO, (char *)&timeout, sizeof(struct timeval));
	setsockopt(i_handle, SOL_SOCKET, SO_SNDTIMEO, (char *)&timeout, sizeof(struct timeval));

    struct sockaddr_in serAddr;
    serAddr.sin_family = AF_INET;
    serAddr.sin_port = htons(port);
    serAddr.sin_addr.s_addr = htons(INADDR_ANY);
    if(bind(i_handle, (struct sockaddr *)&serAddr, sizeof(serAddr))){
        printf("bind error !");
        close(i_handle);
        return 0;
    }

    struct   sockaddr_in remoteAddr;
    int nAddrLen = sizeof(remoteAddr);

	gettimeofday(&startt, 0);
	FILE *fd1 = NULL;
	char str[500] = { 0 };
	fd1 = fopen("./TMCCP/PIDBitrate","wb");
	if(fd1 == NULL) {
		exit(1);		
	}

	while (1) {
		unsigned char buffer[1316];
		int pid, ok;
		ssize_t r;

		if ((r = recvfrom(i_handle, buffer, 1316, 0, (struct sockaddr *)&remoteAddr, (socklen_t*)&nAddrLen)) <=0) {
			perror("read");
			break;
		}
		if (r != 1316) {
			fprintf(stderr, "calc: only read %zd bytes\n", r);
			break;
		}
		if (buffer[0] != 0x47) {
			continue;
			printf("desync (%x)\n", buffer[0]);
			while (buffer[0] != 0x47)
				continue;
		}

		int k=0;
		for(k=0;k<7;k++){
			ok = 1;
			pid = ((((unsigned) buffer[1+k*188]) << 8) |
			       ((unsigned) buffer[2+k*188])) & 0x1FFF;

			if (search) {
				int i, sl = strlen(search);
				ok = 0;
				if (pid != 0x1fff) {
					for (i = 0; i < (188 - sl); ++i) {
						if (!memcmp(buffer + i + k*188, search, sl))
							ok = 1;
					}
				}
			}


			if (ok) {
				pidt[pid]++;
				pidt[0x2000]++;
			}

			packets++;

			if (!(packets & 0xFF)) {
				struct timeval now;
				int diff;
				gettimeofday(&now, 0);
				diff =
				    (now.tv_sec - startt.tv_sec) * 1000 +
				    (now.tv_usec - startt.tv_usec) / 1000;
				if (diff > 1000) {
					int _pid = 0;
					for (_pid = 0; _pid < 0x2001; _pid++) {
						if (pidt[_pid] && (flag == 2)) {
							sprintf(str,"%d  %04x %5d %5d %5d\n",
								 _pid,
							     _pid,
							     pidt[_pid] * 1000 / diff,
							     pidt[_pid] * 1000 / diff * 188 / 1024,
							     pidt[_pid] * 8 * 1000 / diff * 188);
							printf("%d  %04x %5d p/s %5d kb/s %5d kbit\n",
								 _pid,
							     _pid,
							     pidt[_pid] * 1000 / diff,
							     pidt[_pid] * 1000 / diff * 188 / 1024,
							     pidt[_pid] * 8 * 1000 / diff * 188 / 1000);
							fputs(str,fd1);
						}
						pidt[_pid] = 0;

					}
					//printf("-PID--FREQ-----BANDWIDTH-BANDWIDTH-\n");
					startt = now;
					flag++;
					//printf("flag=%d\n",flag);
					if(flag==3)
						return 0;
				}

			}
		}
	}

	if(fd1 != NULL) {fclose(fd1);}
	close(i_handle);
	return 0;
}
