#include "FilePro.h"

/***************************************
Function: findchar
Description: 查找字符串中指定字符的个数
Input:
	string	字符串
	Char	指定字符
return: 成功返回指定字符的个数
***************************************/
unsigned int findchar(unsigned char *string,unsigned char Char)
{
    int num=0; 
	unsigned char *str = string;
    while(NULL != str++ && *str != '\0')
    {		
		if(*str == Char)
		{
			num++;
		}
    }
    return num;
}


/***************************************
Function: urldecode
Description: 解url编码实现（URL-encode->ASCII Value）
Input:
	encd	URL-encode
return: 成功返回ASCII Value
***************************************/
unsigned char* urldecode(unsigned char* encd,unsigned char* decd)
{
    int i = 0,j = 0;
    char *cd = encd;
    char p[2];
    unsigned int num;

    for( i = 0; i < strlen(cd); i++ )
    {
        memset(p,0,2 );
        if( cd[i] != '%' )
        {
            decd[j++] = cd[i];
            continue;
        }
 
		p[0] = cd[++i];
		p[1] = cd[++i];

		p[0] = p[0] - 48 - ((p[0] >= 'A') ? 7 : 0) - ((p[0] >= 'a') ? 32 : 0);
		p[1] = p[1] - 48 - ((p[1] >= 'A') ? 7 : 0) - ((p[1] >= 'a') ? 32 : 0);
		decd[j++] = (unsigned char)(p[0] * 16 + p[1]);
 
    }
    decd[j] = '\0';
    return decd;
} 

/***************************************
Function: RegMatch
Description: 匹配组播IP地址
Input:
	pattern		正则表达式字符串
	str			目标串
return: 成功返回0,失败返回1
***************************************/
int RegMatch(char *pattern, char *str)
{
	int status = -1,i;
	int flag=REG_EXTENDED;	
	regmatch_t pmatch[1];
	const size_t nmatch=1;
	regex_t  reg;
	//编译正则模式,成功返回0
	status = regcomp(&reg,pattern,flag);
	if(status != 0)
	{
		//printf("编译失败\n");
		return -1;
	}

	//执行正则表达式和缓存的比较，成功返回0,失败返回REG_NOMATCH
	status=regexec(&reg,str,nmatch,pmatch,0);
	if(status != 0)
	{
		//printf("匹配失败\n");
		return -1;
	}

	//打印匹配的字符串
	/*for(i=pmatch[0].rm_so;i<pmatch[0].rm_eo;++i){
		putchar(str[i]);
	}
	printf("\n");*/
	regfree(&reg);
	return 0;
}



/***************************************
Function: replace
Description: 字符替换
Input:
	buffer	源字符串
	dest	待替换的字符
	ch		指定替换成的字符
return: 无返回值
***************************************/
void replace(char *buffer,const char dest,const char ch)
{
	char *p = NULL;
	while(1)
	{
		p = strchr(buffer,dest);
		if(p == NULL)
			break;
		*p++ = ch;
	} 
}     
  

/***************************************
Function: split
Description: 字符串切割
Input:
	src			源字符串的首地址
	separator	指定的分割字符
	dest		接收子字符串的数组
	num			分割后子字符串的个数
return: 无返回值
***************************************/
int split(char *src,const char *separator,char **dest)
{
	char *pNext;
	int count = 0;
	if (src == NULL || strlen(src) == 0)
		return;
	if (separator == NULL || strlen(separator) == 0)
		return;    
	pNext = strtok(src,separator);
	while(pNext != NULL) {
		*dest++ = pNext;
		++count;
		pNext = strtok(NULL,separator);  
	}  
	return count;
}   


/***************************************
Function: trim
Description: 删除字符串首尾空格
Input:
	str		源字符串的首地址
return: 成功返回新字符串首地址
***************************************/
char *trim(char* str)
{
	if (str == NULL || *str == '\0')
	{
		return str;
	}
	char *start = str;

	int i=0;
	while (isspace(*start) && *start)
	{
		++start;
		++i;
	}
	int len = strlen(str);
	char *end = str + len -1;

	while (*end && isspace(*end)){
		*end = '\0';
		--end;
	}
	memmove(str, start, strlen(str) - i + 1);
	return str;
}


/***********************************************************
Function: LocalFile
Description: 应用的网络LocalFile流信息汇总到EnableSource文件中
Input:
	LocalEnable		保存的LocalFile应用的url，name
	EnableSource	将使能信息汇总到该文件
	string			进程是否执行的关键字符串
return: 无返回值
***********************************************************/
void LocalFile(char *LocalEnable, char *EnableSource, char *string)
{
	FILE *fd = NULL, *fd1 = NULL;
	char buffer[80]={ 0 };
	char str[512] = { 0 };

	memset(str,0,sizeof(str));
	strcpy(str,"ps -ef | grep -w '");
	strcat(str,string);
	strcat(str,"' | grep -v grep | awk '{print $2}'");
	//printf("%s\n",str);
	FILE *Pd = popen(str,"r");
	if(Pd != NULL)
	{
		fgets(buffer, sizeof(buffer), Pd);//获取进程PID
		if(strlen(buffer) > 0)
		{
			fd = fopen(LocalEnable,"rb");
			fd1 = fopen(EnableSource,"ab");
			if(fd != NULL && fd1 != NULL)
			{
				memset(str,0,sizeof(str));
				while(fgets(str,sizeof(str),fd))
				{
					fputs(str,fd1);	
				}
				fclose(fd);
				fclose(fd1);
			}
		}
		pclose(Pd);
	}
}

/***********************************************************
Function: SPTS
Description: 应用的网络SPTS流信息汇总到EnableSource文件中
Input:
	SPTSEnable		保存的SPTS应用的url，name
	EnableSource	将使能信息汇总到该文件
	string			进程是否执行的关键字符串
	string1			cgi-bin目录下bitrate=0,SPTS是否执行标志文件
return: 无返回值
***********************************************************/
void SPTS(char *SPTSEnable, char *EnableSource, char *string, char *string1)
{
	FILE *fd = NULL, *fd1 = NULL, *fd2 = NULL, *Pd = NULL, *Pd1 = NULL;
	char buffer[80]={ 0 };
	char buffer1[80]={ 0 };
	char str[512] = { 0 };
	char str1[150] = { 0 };
	char str2[150] = { 0 };

	memset(str,0,sizeof(str));
	strcpy(str,"ps -ef | grep -w '");
	strcat(str,string);
	strcat(str,"' | grep -v grep | awk '{print $2}'");
	//printf("%s\n",str);
	if((Pd = popen(str,"r")) != NULL)
	{
		fgets(buffer, sizeof(buffer), Pd);//获取进程PID
		pclose(Pd);
	}

	strcpy(str1,"/usr/local/tbs/apache2.4.3/htdocs/www/cgi-bin/");
	strcat(str1,string1);
	if((fd2 = fopen(str1,"rd")) != NULL)
	{
		strcpy(str2,"grep -w 'ApplySPTSMark = 1' /usr/local/tbs/apache2.4.3/htdocs/www/cgi-bin/");
		strcat(str2,string1);
		Pd1 = popen(str2,"r");
		if(Pd1 != NULL)
		{
			fgets(buffer1, sizeof(buffer1), Pd1);
		}
		pclose(Pd1);
	}
	if(strlen(buffer) > 0 || strlen(buffer1) > 0)
	{
		//printf("\n\nbuffer = %d  buffer1 = %d\n\n",strlen(buffer),strlen(buffer1));
		fd = fopen(SPTSEnable,"rb");
		fd1 = fopen(EnableSource,"ab");
		if(fd != NULL && fd1 != NULL)
		{
			memset(str,0,sizeof(str));
			while(fgets(str,sizeof(str),fd))
			{
				fputs(str,fd1);	
			}
			fclose(fd);
			fclose(fd1);
		}
	}
}

/***********************************************************
Function: MPTS
Description: 应用的网络MPTS流信息汇总到EnableSource文件中
Input:
	FileName		文件名
return: 无返回值
***********************************************************/
void MPTS(char *FileName)
{
	FILE *fd = NULL, *fd1 = NULL, *Pd = NULL;
	char buffer[80]={ 0 };
	char FileNameP[30]={ 0 };
	char str[512] = { 0 };

	memset(str,0,sizeof(str));
	strcpy(str,"ps -ef | grep -w 'dvblast.*-c.*DVBLAST");
	strcat(str,&FileName[10]);
	strcat(str,"' | grep -v grep | awk '{print $2}'");
	//printf("str = %s\n",str);

	memset(buffer,0,sizeof(buffer));
	if((Pd = popen(str,"r")) != NULL)
	{
		fgets(buffer, sizeof(buffer), Pd);
		if(strlen(buffer) > 0)
		{
			//printf("\nbuffer=%s\n",buffer);
			strcpy(FileNameP,"./config/");
			strcat(FileNameP,FileName);
			//printf("\nFileNameP = %s \n",FileNameP);
			fd = fopen(FileNameP,"rb");
			fd1 = fopen("./config/EnableSource","ab");
			if(fd != NULL && fd1 != NULL)
			{

				while(!feof(fd))
				{
					memset(str,0,sizeof(str));
					fgets(str,sizeof(str),fd);
	
					if(str[0] == '\n' || str[0] == '\r' || str[0] == '\0')
						continue;
					else
					{
						//printf("str = %s",str);
						fputs(str,fd1);	
					}
				}
				fclose(fd);						
				fclose(fd1);
			}
		}
		pclose(Pd);
	}
}


/***********************************************************
Function: PcieCard
Description: PCIE信息汇总到EnableSource文件中
Input:
	FileName		文件名
	PcieA			adapter
return: 无返回值
***********************************************************/
void PcieCard(char *FileName, char *PcieA)
{
	FILE *fd = NULL, *fd1 = NULL, *Pd = NULL;
	char buffer[80] = { 0 };
	char FileNameP[30] = { 0 };
	char str[512] = { 0 };

	memset(str,0,sizeof(str));
	/*strcpy(str,"ps -ef | grep -w 'dvblast.*-5.*-a.*");
	strcat(str,PcieA);
	strcat(str,"' | grep -v grep | awk '{print $2}'");*/
	//使用grep抽取精确匹配的一种有效方式是在抽取字符串前加 \<, 在抽取字符串后加 \>
	sprintf(str,"ps -ef | grep -w 'dvblast.*-5.*-a.*\\<%s\\>' | grep -v grep | awk '{print $2}'",PcieA);
	//printf("str = %s\n",str);

	memset(buffer,0,sizeof(buffer));
	if((Pd = popen(str,"r")) != NULL)
	{
		fgets(buffer, sizeof(buffer), Pd);
		if(strlen(buffer) > 0)
		{
			//printf("\nbuffer=%s\n",buffer);
			strcpy(FileNameP,"./config/");
			strcat(FileNameP,FileName);
			//printf("\nFileNameP = %s \n",FileNameP);
			fd = fopen(FileNameP,"rb");
			fd1 = fopen("./config/EnableSource","ab");
			if(fd != NULL && fd1 != NULL)
			{

				while(!feof(fd))
				{
					memset(str,0,sizeof(str));
					fgets(str,sizeof(str),fd);
	
					if(str[0] == '\n' || str[0] == '\r' || str[0] == '\0')
						continue;
					else
					{
						//printf("str = %s",str);
						fputs(str,fd1);	
					}
				}
				fclose(fd);						
				fclose(fd1);
			}
		}
		pclose(Pd);
	}
}

/*************************************************************************
Function: listDir
Description:  遍历文件夹(一层)，应用的网络MPTS流信息汇总到EnableSource文件中
Input:
		path	 遍历的文件夹路径
return: 无返回值
**************************************************************************/
void listDir(char *path)  
{  
	DIR              *pDir ;  
	struct dirent    *ent  ;  
	char              childpath[512];  

	//char *FileName = NULL;
	int i = 0, j = 0;
	char FileName[512] = { 0 };
	char PcieA[5] = { 0 };

	pDir=opendir(path);  
	if(pDir == NULL){return;}
	memset(childpath,0,sizeof(childpath));

	while((ent=readdir(pDir)) != NULL)  
	{  
		if(ent->d_type & DT_DIR)  
		{  
			if(strcmp(ent->d_name,".") == 0 || strcmp(ent->d_name,"..") == 0)  
				continue;  
			//sprintf(childpath,"%s/%s",path,ent->d_name);  
			//printf("path:%s/n",childpath);  
			//listDir(childpath);  
		}  
		else
		{
			//FileName = (char*)malloc(512);
			strcpy(FileName,ent->d_name);
			if(strncmp(FileName,"MPTSEnable",10) == 0)
			{
				if(strlen(FileName) == 11)
				{
					//printf("\nFileName = %s  %c %d\n",FileName,FileName[10],strlen(FileName));
					MPTS(FileName);
				}
			}
			else if(strncmp(FileName,"PCIECardEnable",14) == 0)
			{
				j = 0;
				memset(PcieA,0,sizeof(PcieA));
				for(i = 14 ; i < strlen(FileName) ; i++)
				{
					PcieA[j] = FileName[i];
					//printf("PcieA[%d]=%c  FileName[%d]=%d\n",j,PcieA[j],i,FileName[i]);
					j++;
				}
				PcieCard(FileName,PcieA);
			}
			//free(FileName);
		}
	}  
	closedir(pDir);
}  

/*************************************************************************
Function: DEnableSelectedItems
Description: 在EnableSource文件删除已经被应用的SelectedItem
Input:
	TBSX			对应的adapter应用的存储文件
	EnableSource	使能有效信息的存储文件
return: 失败返回-1
**************************************************************************/
int DEnableSelectedItems(char *TBSX, char *EnableSource)
{
	int status = -1;
	//char pattern[100] = "((udp|rtp)\\:\\/\\/(2[2-3][4-9])(\\.(2[0-4][0-9]|25[0-5]|[01]?[0-9][0-9]?)){3}:)";
	char pattern[100] = "((udp|rtp)\\:\\/\\/(2[2-3][4-9])(\\.(2[0-4][0-9]|25[0-5]|[01]?[0-9][0-9]?)){3}:)|(http\\:\\/\\/)";

	FILE *fd1 = NULL, *fd2 = NULL, *fd3 = NULL;
	char str1[512] = { 0 };
	char str2[512] = { 0 };

	char tmp[512] = { 0 };
	char *tmp0 = NULL, *tmp1 = NULL;


	if((fd1 = fopen(TBSX,"rb")) == NULL)
	{
		return -1;
	}
	//printf("\nTBSX = %s\n\n",TBSX);
	while(fgets(str1,sizeof(str1),fd1)) //open TBS0_0文件删除EnableSource文件中的url
	{
		if(str1[0] == '\n' || str1[0] == '\r' || str1[0] == '\0')
			continue;
		else
		{
			strcpy(tmp,str1);
			tmp0 = strtok(tmp," ");
			tmp1 = strtok(NULL," ");
			if(tmp0 == NULL || tmp1 == NULL)
			{	
				continue;
			}
			tmp0 = trim(tmp0);
			tmp1 = trim(tmp1);
			if((strcmp("NetworkID",tmp0) == 0) || (strcmp("NetworkName",tmp0) == 0) ||\
			   (strcmp("TransportID",tmp0) == 0) || (strcmp("ProviderName",tmp0) == 0) ||\
			   (strcmp("OutputBitrate",tmp0) == 0) || (strcmp("Frequency",tmp0) == 0) ||\
			   (strcmp("SymbolRate",tmp0) == 0) || (strcmp("Bandwidth",tmp0) == 0) ||\
			   (strcmp("Modulation",tmp0) == 0) || (strcmp("Transmission",tmp0) == 0) ||\
			   (strcmp("GuardInterval",tmp0) == 0) || (strcmp("FEC",tmp0) == 0) ||\
			   (strcmp("Interleave",tmp0) == 0) || (strcmp("Level",tmp0) == 0) ||\
			   (strcmp("OriginalNetworkID",tmp0) == 0))
			{
				continue;
			}

			fd2 = fopen(EnableSource,"rb");
			fd3 = fopen("./config/tmp","wb");
			if(fd2 == NULL || fd3 == NULL)
			{
				continue;
			}
			while(fgets(str2,sizeof(str2),fd2))
			{
				//printf("str1 = %s",str1);
				//printf("str2 = %s",str2);
				if(strcmp(str1,str2) == 0)//url相等，判断是单播还是组播，单播则在EnableSource删除，组播则不删除
				{
					//printf("str1 = %s",str1);
					//printf("str2 = %s",str2);
					status = RegMatch(pattern,str2);
					if(status == 0)
					{
						//printf("%s",str2);
						fputs(str2,fd3);
					}
					str2[0] = '\0';
				}
				else
				{
					//printf("str2 = %s",str2);
					fputs(str2,fd3);
				}
				//printf("\n");
			}
			//printf("\n\n");
			fclose(fd2);
			fclose(fd3);
			remove("./config/EnableSource");
			rename("./config/tmp","./config/EnableSource");
		}
	}	
	fclose(fd1);
}

/*************************************************************************
Function: AvailableSelected
Description: 区分Available Items和Selected Items
			 即在EnableSource文件删除已经被应用的
Input:
	DFile			存放设备端口号的文件
	EnableSource	使能有效信息的存储文件
return: 失败返回-1
**************************************************************************/
int AvailableSelected(char *DFile, char *EnableSource)
{

	FILE *fd = NULL;
	char str[20] = { 0 };
	char adapter[10] = { 0 };
	char TBSX[30] = { 0 };
	char tmp[30] = { 0 };
	char *tmp0 = NULL, *tmp1 = NULL;

	if((fd= fopen(DFile,"rb")) == NULL){return -1;}

	//system("cp ./config/EnableSourceTotal ./config/EnableSource");
	while(fgets(str,sizeof(str),fd)) //获取tbsci.conf中的“adapter0/sec0”
	{
		memset(adapter,0,sizeof(adapter));
		strcpy(tmp,str);
		tmp0 = strtok(tmp,"/");
		tmp1 = strtok(NULL,"/");
		if(tmp0 == NULL || tmp1 == NULL)
		{	
			continue;
		}
		tmp0 = trim(tmp0);
		tmp1 = trim(tmp1);
		if(strlen(str) == 16 && strncmp(tmp0,"\"adapter",8) == 0 && strncmp(tmp1,"sec",3) == 0)
		{
			adapter[0] = (char)str[8];
			adapter[1] = '_';
			adapter[2] = str[13];
			adapter[3] = '\0';
		}	
		else if(strlen(str) == 16 && strncmp(tmp0,"\"tbsdvbc",8) == 0 && strncmp(tmp1,"mod",3) == 0)
		{
			adapter[0] = 'C';
			adapter[1] = '_';
			adapter[2] = (char)str[8];
			adapter[3] = '_';
			adapter[4] = str[13];
			adapter[5] = '\0';
		}
		else if(strlen(str) == 16 && strncmp(tmp0,"\"tbsdvbt",8) == 0 && strncmp(tmp1,"mod",3) == 0)
		{
			adapter[0] = 'T';
			adapter[1] = '_';
			adapter[2] = (char)str[8];
			adapter[3] = '_';
			adapter[4] = str[13];
			adapter[5] = '\0';
		}
		else if(strlen(str) == 16 && strncmp(tmp0,"\"tbsqamb",8) == 0 && strncmp(tmp1,"mod",3) == 0)
		{
			adapter[0] = 'B';
			adapter[1] = '_';
			adapter[2] = (char)str[8];
			adapter[3] = '_';
			adapter[4] = str[13];
			adapter[5] = '\0';
		}
		else if(strlen(str) == 15 && strncmp(tmp0,"\"tbsasi",7) == 0 && strncmp(tmp1,"mod",3) == 0)
		{
			adapter[0] = 'A';
			adapter[1] = '_';
			adapter[2] = (char)str[7];
			adapter[3] = '_';
			adapter[4] = str[12];
			adapter[5] = '\0';
		}
		else if(strlen(str) == 17 && strncmp(tmp0,"\"tbsisdbt",9) == 0 && strncmp(tmp1,"mod",3) == 0)
		{
			adapter[0] = 'I';
			adapter[1] = '_';
			adapter[2] = (char)str[9];
			adapter[3] = '_';
			adapter[4] = str[14];
			adapter[5] = '\0';
		}
		else if(strlen(str) == 16 && strncmp(tmp0,"\"tbsatsc",8) == 0 && strncmp(tmp1,"mod",3) == 0)
		{
			adapter[0] = 'S';
			adapter[1] = '_';
			adapter[2] = (char)str[8];
			adapter[3] = '_';
			adapter[4] = str[13];
			adapter[5] = '\0';
		}

		strcpy(TBSX,"./config/TBS");
		strcat(TBSX,adapter);
		//printf("adapter = %s    TBSX = %s\n",adapter,TBSX);
		DEnableSelectedItems(TBSX,EnableSource);
	}
	fclose(fd);
}


/*************************************************************************
Function: PrintFile
Description: 输出对应的Available Items和Selected Items
Input:
	adapter			设备端口号
	EnableSource	Available Items
return: 无返回值
**************************************************************************/
void PrintFile(char *adapter,char *EnableSource)
{
	FILE *fd = NULL, *fd1 = NULL;
	char str[512] = { 0 };
	char TBSX[30] = { 0 };

	strcpy(TBSX,"./config/TBS");
	strcat(TBSX,adapter);
	if((fd = fopen(TBSX,"rb")) != NULL)
	{
		printf("SelectedItems\n");
		while(!feof(fd))
		{
			memset(str,0,sizeof(str));
			fgets(str,sizeof(str),fd);
			if(str[0] == '\n' || str[0] == '\r' || str[0] == '\0')
				continue;
			else
			{
				printf("%s",str);
			}
		}
		fclose(fd);
	}
	if((fd1 = fopen(EnableSource,"rb")) != NULL)
	{
		printf("AvailableItems\n");
		while(!feof(fd1))
		{
			memset(str,0,sizeof(str));
			fgets(str,sizeof(str),fd1);
			if(str[0] == '\n' || str[0] == '\r' || str[0] == '\0')
				continue;
			else
			{
				printf("%s",str);
			}
		}
		fclose(fd1);
	}
}



