#!/bin/sh

echo "content-type: text/html"
echo
echo

#cc=`ls /sys/class/net/ | grep eth* `
cc=`ls /sys/class/net/ `
eth1=`echo $cc | cut -f 1 -d " "`
eth2=`echo $cc | cut -f 2 -d " "`

#lan1 info
strip=$(echo `ip addr`  | grep ${eth1})
if [ "$strip" = "" ]; then
	ipaddr=0.0.0.0
	submask=0.0.0.0
	gateway=0.0.0.0
	dns=0.0.0.0
else	
	ipaddr=`ip addr | grep ${eth1} | grep "inet" | awk 'NR==1 {print $2}'|cut -f 1 -d "/"`
	if [ "$ipaddr" = "" ]; then
		ipaddr=0.0.0.0
		submask=0.0.0.0
		gateway=0.0.0.0
		dns=0.0.0.0
		dhcp=0
	else	
		line=`ifconfig ${eth1} | grep netmask | awk 'NR==1 {print $4}'`
		if [ $line ]; then
			submask=$line
		else
			submask=255.255.255.0
		fi

		#gateway=`routel | sed -n '2p' |  awk 'NR==1 {print $2}'`
		line=`nmcli device show ${eth1} | sed -n '10p' | awk 'NR==1 {print $1}'`
		flag=`echo $line | grep "IP4." `
		if [ $flag ]; then
       		gateway=`nmcli device show ${eth1} | sed -n '10p' | awk 'NR==1 {print $2}'`
		else
        	gateway=0.0.0.0
		fi

		#dns=`cat /etc/resolv.conf | grep nameserver | awk 'NR==1 {print $2}'`
		line=`nmcli device show ${eth1} | sed -n '11p' | awk 'NR==1 {print $1}'`
        flag=`echo $line | grep "IP4." `
        if [ $flag ]; then
        	dns=`nmcli device show ${eth1} | sed -n '11p' | awk 'NR==1 {print $2}'`
        else
        	dns=0.0.0.0
        fi

		dhcp=`grep "BOOTPROTO" /etc/sysconfig/network-scripts/ifcfg-${eth1} | cut -d '=' -f 2`
        if [ $dhcp ] && [ "$dhcp" = "dhcp" ]; then
        	dhcp=1
        else
        	dhcp=0
        fi
		

	fi		
fi

#lan2 info
str=$(echo `ip addr`  | grep ${eth2})
if [ "$str" = "" ]; then
	wipaddr=0.0.0.0
	wsubmask=0.0.0.0
	wgateway=0.0.0.0
	wdns=0.0.0.0
	dhcp=0
else	
	wipaddr=`ip addr | grep ${eth2} | grep "inet" | awk 'NR==1 {print $2}'|cut -f 1 -d "/"`
	if [ "$wipaddr" = "" ]; then
		wipaddr=0.0.0.0
		wsubmask=0.0.0.0
		wgateway=0.0.0.0
		wdns=0.0.0.0
	else	
		line=`ifconfig ${eth2} | grep netmask | awk 'NR==1 {print $4}'`
        if [ $line ]; then
        	wsubmask=${line}
		else
			wsubmask=255.255.255.0
		fi
		#wgateway=`routel | sed -n '3p' |  awk 'NR==1 {print $2}'`
		line=`nmcli device show ${eth2} | sed -n '10p' | awk 'NR==1 {print $1}'`
		flag=`echo $line | grep "IP4." `
		if [ $flag ]; then
			wgateway=`nmcli device show ${eth2} | sed -n '10p' | awk 'NR==1 {print $2}'`
		else
			wgateway=0.0.0.0
		fi
		#wdns=`cat /etc/resolv.conf | grep nameserver | awk 'NR==1 {print $2}'`
		line=`nmcli device show ${eth2} | sed -n '11p' | awk 'NR==1 {print $1}'`
		flag=`echo $line | grep "IP4." `
		if [ $flag ]; then
			wdns=`nmcli device show ${eth2} | sed -n '11p' | awk 'NR==1 {print $2}'`
		else
			wdns=0.0.0.0
		fi

		wdhcp=`grep "BOOTPROTO" /etc/sysconfig/network-scripts/ifcfg-${eth2} | cut -d '=' -f 2`
        if [ $wdhcp ] && [ "$wdhcp" = "dhcp" ]; then
        	wdhcp=1
        else
        	wdhcp=0
        fi
	fi		
fi

ipfile="./network.conf"
#if [ -f $ipfile ]; then
#  	sed -i "3s:.*:ip1\:$ipaddr:g"  			>> $ipfile
#  	sed -i "4s:.*:submask1\:$submask:g"  	>> $ipfile
#  	sed -i "5s:.*:gateway1\:$gateway:g"  	>> $ipfile
#  	sed -i "6s:.*:dns1\:$dns:g"  			>> $ipfile
#  	sed -i "9s:.*:ip2\:${wipaddr}:g"  		>> $ipfile
#  	sed -i "10s:.*:submask2\:${wsubmask}:g"	>> $ipfile
#  	sed -i "11s:.*:gateway2\:${wgateway}:g"	>> $ipfile
#  	sed -i "12s:.*:dns2\:${wdns}:g"  		>> $ipfile
#else

#fi
if [ -f $ipfile ]; then
	rm -rf $ipfile
fi

echo "LAN1:1"				>> $ipfile
echo "dhcp1:$dhcp"			>> $ipfile
echo "ip1:$ipaddr"			>> $ipfile 
echo "submask1:$submask"	>> $ipfile 
echo "gateway1:$gateway"	>> $ipfile
echo "dns1:$dns"			>> $ipfile
echo "LAN2:2"				>> $ipfile
echo "dhcp2:$wdhcp"			>> $ipfile
echo "ip2:${wipaddr}"		>> $ipfile 
echo "submask2:${wsubmask}"	>> $ipfile 
echo "gateway2:${wgateway}"	>> $ipfile
echo "dns2:${wdns}"			>> $ipfile

while read line
do
	echo $line
done < $ipfile

