#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <errno.h>
#include <dirent.h>  
#include <sys/stat.h>  
#include <unistd.h>  
#include <sys/types.h> 
#include <regex.h>

int split(char *src,const char *separator,char **dest)
{
	char *pNext;
	int count = 0;
	if (src == NULL || strlen(src) == 0)
		return 0;
	if (separator == NULL || strlen(separator) == 0)
		return 0;    
	pNext = strtok(src,separator);
	while(pNext != NULL) {
		*dest++ = pNext;
		++count;
		pNext = strtok(NULL,separator);  
	}  
	return count;
}   

int RegMatch(char *pattern, char *str)
{
	int status = -1,i;
	int flag=REG_EXTENDED;	
	regmatch_t pmatch[1];
	const size_t nmatch=1;
	regex_t  reg;
	//编译正则模式,成功返回0
	status = regcomp(&reg,pattern,flag);
	if(status != 0)
	{
		//printf("编译失败\n");
		return -1;
	}

	//执行正则表达式和缓存的比较，成功返回0,失败返回REG_NOMATCH
	status=regexec(&reg,str,nmatch,pmatch,0);
	if(status != 0)
	{
		//printf("匹配失败\n");
		return -1;
	}

	//打印匹配的字符串
	/*for(i=pmatch[0].rm_so;i<pmatch[0].rm_eo;++i){
		putchar(str[i]);
	}
	printf("\n");*/
	regfree(&reg);
	return 0;
}

int main(int argc,char **argv)
{
	int status = -1;
	char pattern[100] = "((udp|rtp)\\:\\/\\/)|(http\\:\\/\\/)";
	int UrlMark = 0;
	int Bitrate = 0;
	int Enable = 0;
	int FA = 0;
	
	int i = 0, LineN = 0;
	char *tmp = NULL;
	FILE *fd = NULL, *fd1 = NULL, *fd2 = NULL;

	char str[512] = { 0 };
	char str1[512] = { 0 };

	int BitrateMark1 = 0;
	int BitrateMark2 = 0;
	int port = 3656;
	char url[100] = { 0 };
	char name[100] = { 0 };
	char lcn[10] = { 0 };
	char bitrate[10] = { 0 };
	char enabled[10] = { 0 };
	char line[200] = { 0 };

	//url的个数
	int Total = strtol( argv[1], NULL, 0 ); //Total(url)
	char *Row[Total];
	//printf("\n\nTotal=%d\n\n",Total);
	remove("./config/TableText");
	remove("SPTS.lua");
	remove("../remux/config/SPTSEnable");

	if((fd = fopen("./config/TableText","ab")) == NULL)
	{
		return -1;
	}
	if((fd2 = fopen("../remux/config/SPTSEnable","ab")) == NULL)
	{
		return -1;
	}
	//以字符“&”切割字符串，赋值指针数组
	LineN = split(argv[2],"&",Row);
	for(i = 1 ; i < LineN ; i++)//遍历指针数组中指针指向的字符串
	{
		//printf("%s\n",Row[i]);
		tmp = strchr(Row[i],'=');
		tmp++;
		//replace(tmp,'+',' ');//将字符“+”替换成空格
		status = RegMatch(pattern,tmp);//匹配url
		if(status == 0)
		{
			UrlMark = 0;
		}

		if(UrlMark == 0)
		{
			strcpy(url,tmp);
		}
		else if(UrlMark == 1)
		{
			strcpy(name,tmp);
		}
		else if(UrlMark == 2)
		{
			strcpy(lcn,tmp);
		}
		else if(UrlMark == 3)
		{
			strcpy(bitrate,tmp);
		}
		else if(UrlMark == 4)
		{
			strcpy(enabled,tmp);

    		sprintf(line, "%s %s %s %s %s\n", url,name,lcn,bitrate,enabled);
			fputs(line,fd);
			//printf("%s\n",line);
    		Bitrate = atoi(bitrate);
    		Enable = atoi(enabled);
			//printf("Bitrate=%d Enable=%d\n",Bitrate, Enable);
			if(Enable == 1 && Bitrate == 0)
			{
				sprintf(line, "%s %s %s\n", url,name,lcn);
				fputs(line,fd2);
				BitrateMark1 = 1;
			}
			else if(Enable == 1 && Bitrate != 0)
			{
				if(FA == 0)
				{
					if((fd1 = fopen("SPTS.lua","ab")) == NULL)
					{
						return -1;
					}
					fputs("#!/usr/bin/env astra-4.3\n",fd1);
					fputs("\n",fd1);
					fputs("log.set({ syslog = \"astra0\"})\n",fd1);
					fputs("pidfile(\"/var/run/astra0.pid\")\n",fd1);
					fputs("\n",fd1);
				}
				//printf("Bitrate=%d Enable=%d\n",Bitrate, Enable);
				fputs("make_channel({\n",fd1);
				sprintf(line, "   name = \"%s\",\n", name);
				fputs(line,fd1);
				fputs("   input = {\n",fd1);
				sprintf(line, "       \"%s\"\n", url);
				fputs(line,fd1);
				fputs("   },\n",fd1);
				fputs("   output = {\n",fd1);
				sprintf(line, "       \"udp://127.0.0.1:%d#sync&cbr=%d\"\n", port, Bitrate);
				fputs(line,fd1);
				fputs("   }\n",fd1);
				fputs("})\n",fd1);
				fputs("\n",fd1);

				sprintf(line, "udp://127.0.0.1:%d %s %s\n", port,name,lcn);
				fputs(line,fd2);
				BitrateMark2 = 1;
				FA++;
			}
			port++;
			//memset(url,0,sizeof(url));
			//memset(name,0,sizeof(name));
		}
		//printf("%d %s\n",UrlMark ,Row[i]);
		UrlMark++;
	}
	fclose(fd);
	if(fd1 != NULL)
		fclose(fd1);
	fclose(fd2);

	//printf("BitrateMark1=%d  BitrateMark2=%d\n\n",BitrateMark1,BitrateMark2);
	if(BitrateMark1 == 1)
	{
		remove("./config/ApplySPTS.conf");
		if((fd = fopen("./config/ApplySPTS.conf","wb")) == NULL)
		{
			return -1;
		}
		fputs("ApplySPTSMark = 1\n",fd);
		if(BitrateMark2 == 0)
		{
			printf("success\n");
		}

	}

	return BitrateMark2;
}
