#!/bin/bash

echo "content-type: text/html; charset=utf8"
echo
echo

read LINE
#LINE="Tuner=0&DVBS=DVB-S2&Frq=11171000&SymRt=43200000&Plr=v&Mdl=psk_8&Fec=AUTO"

LINE=$(echo $LINE | sed 's/&/ /g')
AdapterX=$(echo $LINE | awk '{print $1}' | cut -d '=' -f 2)
DVB=$(echo $LINE | awk '{print $2}' | cut -d '=' -f 2)
Frq=$(echo $LINE | awk '{print $3}' | cut -d '=' -f 2)
SymRt=$(echo $LINE | awk '{print $4}' | cut -d '=' -f 2)
Plr=$(echo $LINE | awk '{print $5}' | cut -d '=' -f 2)
Mdl=$(echo $LINE | awk '{print $6}' | cut -d '=' -f 2)
FEC=$(echo $LINE | awk '{print $7}' | cut -d '=' -f 2)

ps -ef | grep -w "dvblast.*-5.*-a\s${AdapterX}" | grep -v grep | awk '{print $2}' | xargs kill -9 > /dev/null 2>&1
ps -ef | grep -w 'tbsstream PrgAnalysis.lua' | grep -v grep | awk '{print $2}' | xargs kill -9 > /dev/null 2>&1
EnableSign="/usr/local/tbs/apache2.4.3/htdocs/www/configs/pciecard.conf"
if [ -f $EnableSign ]; then
	sed -i "/adapter${AdapterX}/d" $EnableSign
fi

#dvblast -f 11110000 -s 45000000 -v 13 -m psk_8 -a 0 -n 1 -u -d 127.0.0.1:1234
frontend1=`ls /dev/dvb/adapter$AdapterX/ | grep "frontend1"`

if [ "$DVB" = "DVB-S" ]; then
	if [ -n "$frontend1" ] && [ "$Plr" = "v" ]; then
		dvblast -f $Frq -s $SymRt -v 13 -n 1 -5 DVBS -a $AdapterX -u -d 127.0.0.1:1234 > /dev/null 2>&1 &
	elif [ -n "$frontend1" ] && [ "$Plr" = "H" ]; then
		dvblast -f $Frq -s $SymRt -v 18 -n 1 -5 DVBS -a $AdapterX -u -d 127.0.0.1:1234 > /dev/null 2>&1 &
	elif [ ! -n "$frontend1" ] && [ "$Plr" = "v" ]; then
		dvblast -f $Frq -s $SymRt -v 13 -5 DVBS -a $AdapterX -u -d 127.0.0.1:1234 > /dev/null 2>&1 &
	elif [ ! -n "$frontend1" ] && [ "$Plr" = "H" ]; then
		dvblast -f $Frq -s $SymRt -v 18 -5 DVBS -a $AdapterX -u -d 127.0.0.1:1234 > /dev/null 2>&1 &
	fi
elif [ "$DVB" = "DVB-S2" ]; then
	if [ -n "$frontend1" ] && [ "$Plr" = "v" ]; then
		#dvblast -f 11110000 -s 45000000 -v 13 -m psk_8 -a 0 -n 1 -u -d 127.0.0.1:1234 > /dev/null 2>&1 &
		dvblast -f $Frq -s $SymRt -v 13 -m $Mdl -n 1 -5 DVBS2 -a $AdapterX -u -d 127.0.0.1:1234 > /dev/null 2>&1 &
	elif [ -n "$frontend1" ] && [ "$Plr" = "H" ]; then
		dvblast -f $Frq -s $SymRt -v 18 -m $Mdl -n 1 -5 DVBS2 -a $AdapterX -u -d 127.0.0.1:1234 > /dev/null 2>&1 &
	elif [ ! -n "$frontend1" ] && [ "$Plr" = "v" ]; then
		dvblast -f $Frq -s $SymRt -v 13 -m $Mdl -5 DVBS2 -a $AdapterX -u -d 127.0.0.1:1234 > /dev/null 2>&1 &
	elif [ ! -n "$frontend1" ] && [ "$Plr" = "H" ]; then
		dvblast -f $Frq -s $SymRt -v 18 -m $Mdl -5 DVBS2 -a $AdapterX -u -d 127.0.0.1:1234 > /dev/null 2>&1 &
	fi
fi

TmpFile="./config/TmpFile.conf"
if [ -f $TmpFile ]; then
	rm -rf $TmpFile
fi
ProgramList="./config/ProgramList${AdapterX}.conf"
if [ -f $ProgramList ]; then
	rm -rf $ProgramList
fi

#分析节目，节目号
../../bin/./tbsstream PrgAnalysis.lua > $TmpFile 2>&1 &
timestar=`date +%s`
while true
do
	timeend=`date +%s`
	time=`expr $timeend - $timestar`
	Num=`ls -l $TmpFile | awk '{print $5}'` 
	sleep 1
	Num1=`ls -l $TmpFile | awk '{print $5}'`
	TMP=$(grep "PrgName.*SDT: sid:" $TmpFile  | awk -F 'sid:' '{print $2}' | awk '$1=$1')
	#echo $Num $Num1 $time	
	if [ "$Num" = "$Num1" ] && [ -n "$TMP" ]; then
		break
	fi 
	if [ $time -gt 5 ]; then
		break
	fi
done
ps -ef | grep -w 'tbsstream PrgAnalysis.lua' | grep -v grep | awk '{print $2}' | xargs kill -9 > /dev/null 2>&1

#PrgNmb=()
#PrgSrv=()
#TMP1=$(grep "PrgName.*SDT: sid:" $TmpFile  | awk -F 'sid:' '{print $2}' | awk '$1=$1')
#TMP2=$(grep "PrgName.*SDT:    Service:" $TmpFile | awk -F 'Service:' '{print $2}' | awk '$1=$1' | sed s/[[:space:]]/_/g) 
#PrgNmb=($(echo $TMP1 | awk '{len=split($0,Nmb," ");for(j = 0 ; j <= len ; j++)print Nmb[j]}'))
#PrgSrv=($(echo $TMP2 | awk '{len=split($0,Srv," ");for(j = 0 ; j <= len ; j++)print Srv[j]}'))

#if((${#PrgNmb[@]}==${#PrgSrv[@]})); then	
#	for((k = 0 ; k < ${#PrgNmb[@]} ; k++));
#	do
#		echo ${PrgNmb[k]} ${PrgSrv[k]} >> $ProgramList
#	done
#fi
PrgLine=()
TMP1=$(grep -n "PrgName.*SDT: sid:" $TmpFile | cut -d ":" -f 1)
PrgLine=($(echo $TMP1 | awk '{len=split($0,Nmb," ");for(j = 0 ; j <= len ; j++)print Nmb[j]}'))

if((${#PrgLine[@]} > 0)); then	
	for((k = 0 ; k < ${#PrgLine[@]} ; k++));
	do
		NmbLine=${PrgLine[k]}
		SrvLine=$(expr $NmbLine + 1)
		PrgNmb=$(sed -n "${NmbLine}p" $TmpFile | grep "PrgName.*SDT: sid:" | awk -F 'sid:' '{print $2}' | awk '$1=$1')
		PrgSrv=$(sed -n "${SrvLine}p" $TmpFile | grep "PrgName.*SDT:    Service:" | awk -F 'Service:' '{print $2}' | awk '$1=$1' | sed s/[[:space:]]/_/g)
		if [ -n "$PrgNmb" ] && [ -n  "$PrgSrv" ]; then
			#echo $PrgNmb $PrgSrv
			echo $PrgNmb $PrgSrv >> $ProgramList
		fi
	done
fi

ps -ef | grep -w "dvblast.*-5.*-a\s${AdapterX}" | grep -v grep | awk '{print $2}' | xargs kill -9 > /dev/null 2>&1
#rm -rf $TmpFile


ProgramTotal=$(wc -l ${ProgramList} | cut -d " " -f 1)
if [ -s $ProgramList ] && [ $ProgramTotal -ge 1 ]; then
	echo "ProgramTotal=$ProgramTotal"
	ApplyText="./config/ApplyText${AdapterX}.conf"
	while read line 
	do
		PrgNum=$(echo $line | awk '{print $1}')
		Name=$(echo $line | awk '{print $2}')
		if [ -n "$PrgNum $Name" ] && [ -s $ApplyText ]; then
			Lcn=`grep "^$PrgNum $Name\s" $ApplyText | awk '{print $3}'`
			Enable=`grep "^$PrgNum $Name\s" $ApplyText | awk '{print $4}'`
			echo $PrgNum $Name $Lcn $Enable
		else 
			echo $PrgNum $Name
		fi
	done < $ProgramList
else
	echo "fail"
	#rm -rf $ProgramList #fail 删除文件
	exit 0
fi


Adapter="./config/Adapter$AdapterX.conf"
if [ -f $Adapter ]; then
	rm -rf $Adapter
fi
echo "AdapterX=$AdapterX" 	>> $Adapter
echo "DVB=$DVB" 			>> $Adapter
echo "Frequency=$Frq" 		>> $Adapter
echo "SymbolRate=$SymRt"	>> $Adapter
echo "Polarisation=$Plr"	>> $Adapter
echo "Modulation=$Mdl"		>> $Adapter
echo "FEC=$FEC" 			>> $Adapter
