#!/bin/bash

echo "content-type: text/html; charset=utf8"
echo
echo

read LINE
LINE=`echo $LINE | sed 's/&/ /g'`
TBSI=`echo $LINE | awk '{print $1}' | cut -d '=' -f 2`
tbsmod=`echo $TBSI | cut -d '_' -f 2`
mod=`echo $TBSI | cut -d '_' -f 3`

RemuxM=$(ps -ef | grep -w "remux -S.*-c.*remux_channels${TBSI}.conf" | grep -v grep | awk '{print $2}')
if [ ! -n "$RemuxM" ]; then
	echo "fail"
	rm -rf ./TMCCP/PIDFilter${TBSI}
	exit 0
fi

OutputBitrate=`grep "OutputBitrate" ./config/TBS${TBSI} | cut -d " " -f 2`


ps -ef | grep -w "remux -S.*-c.*remux_channels${TBSI}.conf" | grep -v grep | awk '{print $2}' | xargs kill -9 > /dev/null 2>&1
ps -ef | grep -w "remux -O 127.0.0.1 -P 1234.*remux_channels${TBSI}.conf" | grep -v grep | awk '{print $2}' | xargs kill -9 > /dev/null 2>&1
killall astra > /dev/null 2>&1

rm -rf ./TMCCP/PIDF ./TMCCP/PIDBitrate

File1="./config/remux${TBSI}.conf"
File2="./config/remux_nit${TBSI}.conf"
File3="./config/remux_channels${TBSI}.conf"

if [ -s $File1 ] && [ -s $File2 ] && [ -s $File3 ]; then
	../../bin/./remux -O 127.0.0.1 -P 1234 -B $OutputBitrate -c $File3 -g $File1 -n $File2 > /dev/null 2>&1 &
else
	exit 0
fi

File="PIDFile.lua"
if [ -f $File ]; then
	rm -rf $File
fi

echo "#!/usr/bin/env astra-4.3" 		>> $File
echo "" 								>> $File
echo "log.set({ syslog = \"astra0\"})" 	>> $File 
echo "pidfile(\"/var/run/astra0.pid\")" >> $File
echo "" 								>> $File
echo "make_channel({" 					>> $File
echo "   name = \"program 1\"," 		>> $File
echo "   input = {" 					>> $File
echo "       \"udp://127.0.0.1:1234\""	>> $File
echo "   }," 							>> $File
echo "   output = {" 					>> $File
echo "       \"udp://127.0.0.1:1235\""	>> $File
echo "   }" 							>> $File
echo "})" 								>> $File
echo "" 								>> $File	


AnalyzePIDF="./TMCCP/AnalyzePIDF.conf"
if [ -f $AnalyzePIDF ]; then
	rm -rf $AnalyzePIDF
fi

sleep 3
#分析节目名称，节目号
./astra $File > $AnalyzePIDF 2>&1 &
timestar=`date +%s`
while true
do
	timeend=`date +%s`
	time=`expr $timeend - $timestar`
	Num=`ls -l ./TMCCP/PIDF | awk '{print $5}'` 
	sleep 1.5
	Num1=`ls -l ./TMCCP/PIDF | awk '{print $5}'`
	if [ "$Num" = "$Num1" ]; then
		break
	fi 
	if [ $time -gt 8 ]; then
		break
	fi
done
killall astra > /dev/null 2>&1

./PIDBitrate -i 127.0.0.1 -p 1234 >> $AnalyzePIDF 2>&1

ps -ef | grep -w "remux -O 127.0.0.1 -P 1234.*remux_channels${TBSI}.conf" | grep -v grep | awk '{print $2}' | xargs kill -9 > /dev/null 2>&1

#echo $tbsmod $mod $OutputBitrate $File3 $File2 $File2 
../../bin/./remux -S -a $tbsmod -A $mod -B $OutputBitrate -c $File3 -g $File1 -n $File2 > /dev/null 2>&1 &

./PIDFB $TBSI

File4="./TMCCP/PIDFilter${TBSI}"
if [ -s ${File4} ]; then
	cat ${File4}
fi

