#!/bin/bash

echo "content-type: text/html; charset=utf8"
echo
echo

read LINE
LINE=$(echo -e "${LINE//%/\\x}")
#echo $LINE

LINE=`echo $LINE | sed 's/%3A/:/g'`
LINE=`echo $LINE | sed 's/%2F/\//g'`
LINE=`echo $LINE | sed 's/&/ /g'`
TBSCTX=`echo $LINE | awk '{print $1}' | cut -d '=' -f 2`
Level=`echo $LINE | awk '{print $2}' | cut -d '=' -f 2`
Frequency=`echo $LINE | awk '{print $3}' | cut -d '=' -f 2`
OutputBitrate=`echo $LINE | awk '{print $4}' | cut -d '=' -f 2`
ProviderName=`echo $LINE | awk '{print $5}' | cut -d '=' -f 2 | sed 's/\+/_/g'`
TransportID=`echo $LINE | awk '{print $6}' | cut -d '=' -f 2`
NetworkName=`echo $LINE | awk '{print $7}' | cut -d '=' -f 2 | sed 's/\+/_/g'`
OriginalNetworkID=`echo $LINE | awk '{print $8}' | cut -d '=' -f 2 | sed 's/\+/_/g'`
NetworkID=`echo $LINE | awk '{print $9}' | cut -d '=' -f 2`
Total=`echo $LINE | awk '{print $10}' | cut -d '=' -f 2`
#echo $TBSCTX $Level  $Frequency $OutputBitrate $ProviderName $TransportID $NetworkName $OriginalNetworkID $NetworkID $Total

ps -ef | grep -w "remux -J.*-c.*remux_channels${TBSCTX}.conf" | grep -v grep | awk '{print $2}' | xargs kill -9 > /dev/null 2>&1


TBS="./config/TBS${TBSCTX}"
if [ -f $TBS ]; then
	rm -rf $TBS
fi
echo "NetworkID $NetworkID"					>> $TBS
echo "OriginalNetworkID $OriginalNetworkID"	>> $TBS
echo "NetworkName $NetworkName"		>> $TBS
echo "TransportID $TransportID"		>> $TBS
echo "ProviderName $ProviderName"	>> $TBS
echo "OutputBitrate $OutputBitrate"	>> $TBS
echo "Frequency $Frequency"			>> $TBS
echo "Level $Level"					>> $TBS

File1="./config/remux${TBSCTX}.conf"
File2="./config/remux_nit${TBSCTX}.conf"
File3="./config/remux_channels${TBSCTX}.conf"
if [ -f $File1 ]; then
	rm -rf $File1
fi
if [ -f $File2 ]; then
	rm -rf $File2
fi
if [ -f $File3 ]; then
	rm -rf $File3
fi
echo "[Global]" 								>> $File1
echo "network_id = $NetworkID"					>> $File1
echo "original_network_id = $OriginalNetworkID"	>> $File1
echo "" 								>> $File1
echo "[Timeouts]" 						>> $File1
echo "pat = 100" 						>> $File1
echo "pmt = 200" 						>> $File1
echo "sdt = 500" 						>> $File1
echo "nit = 2000" 						>> $File1
echo "eit = 1000" 						>> $File1
echo "tdt = 5000" 						>> $File1
echo "tot = 15000" 						>> $File1
echo "stats = 1000" 					>> $File1

NtwName=$(echo $NetworkName | sed 's/\_/ /g')
echo "[Global]"							>> $File2
echo "network_name" = "\"$NtwName\""	>> $File2
echo ""									>> $File2
echo "[Transponder1]"					>> $File2
echo "transport_stream_id = 1"			>> $File2
echo "frequency           = 0658,0000"	>> $File2
echo "modulation          = 64-QAM"		>> $File2
echo "symbol_rate         = 006,8750"	>> $File2

PrvName=$(echo $ProviderName | sed 's/\_/ /g')
echo "[Global]" 							>> $File3
echo "provider_name = $PrvName"				>> $File3
echo "transport_stream_id = $TransportID"	>> $File3
echo "" 									>> $File3

tmp=11
Number=1
while [ 1 ]; do
	#输入target information 
	UrlNameLcn=`echo $LINE | awk -v l=$tmp '{print $l}' | cut -d "=" -f 2`
	url=`echo $UrlNameLcn | cut -d "+" -f 1`
	name=`echo $UrlNameLcn | cut -d "+" -f 2`
	lcn=`echo $UrlNameLcn | cut -d "+" -f 3`

	Name=$(echo $name | sed "s/\_/ /g")
	echo "[Channel$Number]"		>> $File3
	echo "service_id = $Number"	>> $File3
	echo "id = tbs$Number"		>> $File3
	echo "lcn_id = $lcn"		>> $File3
	echo "name = \"$Name\""		>> $File3
	echo "source = $url"		>> $File3
	echo "enable = on"			>> $File3
	echo "" 					>> $File3
	#echo $url $name $lcn
	echo $url $name $lcn >> $TBS

	if [ $Number -ge $Total ]; then
		break
	fi
	((tmp++))
	((Number++))
done
EnableSign="/usr/local/tbs/apache2.4.3/htdocs/www/configs/remux.conf"
if [ -f $EnableSign ]; then
	rm -rf $EnableSign
fi

Card=$(echo $TBSCTX | cut -d "_" -f 2)
Channel=$(echo $TBSCTX | cut -d "_" -f 3)
Frequency=`awk 'BEGIN{printf("%d",'$Frequency' * 1000000)}'`

#echo $Card $Channel $Frequency  $Level $OutputBitrate
if [ -n "$Card" ] && [ -n "$Channel" ] && [ -n "$Frequency" ] && [ -n "$Level" ] && [ -n "$OutputBitrate" ] &&\
   [ -s $File1 ] && [ -s $File2 ] && [ -s $File3 ]; then
	../../bin/./remux -J -a $Card -A $Channel -f $Frequency -Z $Level -B $OutputBitrate -c $File3 -g $File1 -n $File2 > /dev/null 2>&1 &
	if [ $? -eq 0 ]; then
		sleep 1
		RemuxM=$(ps -ef | grep -w "remux -J.*-c.*remux_channels${TBSCTX}.conf" | grep -v grep | awk '{print $2}')
		if [ ! -n "$RemuxM" ]; then
			rm -rf $File1 $File2 $File3
			echo "fail"
			exit 0
		fi


		tbsdvbs=$(ps -ef | grep -w "remux.*-c.*remux_channels.*" | grep -v grep  | awk -F '/' '{print $NF}' | sed 's/remux_nit//g' | cut -f 1 -d '.')
		tbsdvb=($(echo $tbsdvbs | awk '{len=split($0,Nmb," ");for(j = 0 ; j <= len ; j++)print Nmb[j]}'))
		if((${#tbsdvb[@]} > 0)); then	
			for((k = 0 ; k < ${#tbsdvb[@]} ; k++));
			do
				echo "TBS${tbsdvb[k]} = 1" >> $EnableSign
			done
		fi 
		echo "success"
	else 
		ps -ef | grep -w "remux -J.*-c.*remux_channels${TBSCTX}.conf" | grep -v grep | awk '{print $2}' | xargs kill -9 > /dev/null 2>&1
		rm -rf $File1 $File2 $File3
		echo "fail"
	fi
fi

