#!/bin/bash

dvbct="/usr/local/tbs/apache2.4.3/htdocs/www/configs/dvbct.conf"
remux="/usr/local/tbs/apache2.4.3/htdocs/www/configs/remux.conf"
ISDBT="/usr/local/tbs/apache2.4.3/htdocs/www/cgi-bin/remux/./ISDBT"

Log="/usr/local/tbs/apache2.4.3/htdocs/www/cgi-bin/remux/ReloadLog"

rm -rf /usr/local/tbs/apache2.4.3/htdocs/www/cgi-bin/remux/ReloadLog/AD9789*
rm -rf /usr/local/tbs/apache2.4.3/htdocs/www/cgi-bin/remux/ReloadLog/ISDBTI*
rm -rf /usr/local/tbs/apache2.4.3/htdocs/www/cgi-bin/remux/ReloadLog/PIDFilterI*

LoadISDBTPID(){
	ISDBTC="/usr/local/tbs/apache2.4.3/htdocs/www/cgi-bin/remux/TMCCP/ISDBTI_${tbsmod}_${mod}"
	PIDFilter="/usr/local/tbs/apache2.4.3/htdocs/www/cgi-bin/remux/TMCCP/PIDFilterI_${tbsmod}_${mod}"
	if [ -s $ISDBTC ]; then
		#echo ${tbsmod} ${mod} $ISDBTC
		${ISDBT} -a $tbsmod -b $mod -I $ISDBTC > ${Log}/ISDBTI_${tbsmod}_${mod}
	fi

	if [ -s $PIDFilter ]; then
		#echo ${tbsmod} ${mod} $PIDFilter
		${ISDBT} -a $tbsmod -b $mod -P $PIDFilter > ${Log}/PIDFilterI_${tbsmod}_${mod}
	fi
}

if [ -s $dvbct ]; then
	while read line
	do
		mark=`echo $line | grep "tbsisdbt" | sed -e "s/\"//g" -e "s/tbsisdbt//g" -e "s/\/mod/_/g"`
		if [ -n "${mark}" ]; then
			tbsmod=$(echo ${mark} | cut -d "_" -f 1)
			mod=$(echo ${mark} | cut -d "_" -f 2)
			LoadISDBTPID $tbsmod $mod
		fi
	done < $dvbct
fi

AD9789(){
	TBSI="/usr/local/tbs/apache2.4.3/htdocs/www/cgi-bin/remux/config/TBSI_${tbsmod1}_${mod1}"
	Level=$(grep "Level" ${TBSI} | cut -d " " -f 2)
	if [ $mod1 -eq 0 ]; then
		Frequency=$(grep "Frequency" ${TBSI} | cut -d " " -f 2)
		Bandwidth=$(grep "Bandwidth" ${TBSI} | cut -d " " -f 2)
		#echo ${tbsmod1} ${mod1} $Frequency $Bandwidth $Level
		${ISDBT} -a ${tbsmod1} -b ${mod1} -F ${Frequency} -B ${Bandwidth} -G ${Level}  > ${Log}/AD9789_${tbsmod1}_${mod1}
	else
		channel=$((mod1 + 1))
		#echo $tbsmod1 $mod1 $channel $Level
		${ISDBT} -a ${tbsmod1} -b ${mod1} -c ${channel} -G ${Level}  > ${Log}/AD9789_${tbsmod1}_${mod1}
	fi
}

if [ -s $remux ]; then
	while read line
	do
		line=`echo $line | grep "TBSI" | sed -e "s/TBSI_//g"`
		mark1=`echo ${line} | cut -d "=" -f 1`
		mark2=`echo ${line} | cut -d "=" -f 2`
		if [ -n "$mark1" ] && [ $mark2 -eq 1 ]; then
			tbsmod1=$(echo ${mark1} | cut -d "_" -f 1)
			mod1=$(echo ${mark1} | cut -d "_" -f 2)
			AD9789 $tbsmod1 $mod1

		fi
	done < $remux
fi
